<?php

/****************************
* Configuring a node
*****************************/

require_once('../includes/functions.php');
require_once('../includes/includes.php');
require_once('../includes/header.php');


$node = $_POST['editnode'];
$debug = false;
$configfile = getAcutualConfigFile($node);
$nodeconfiguration = explodeConfigArray($configfile);

if($debug) {
	echo "<table><tr><td>";
	echo "<pre>";
	print_r($nodeconfiguration);
	"</pre>";
}

//load the current configuration
$nodeconfiguration = fillConfigArrayWithPosts($nodeconfiguration);


/****************************
* Saving the configuration
*****************************/
if(isset($_POST['save'])) {
	$error = checkForm();
	if($error != "") {
		$messagetype = "error";
		$message = $error;
		showMessage($messagetype, $message);
	} else {
		deleteNodeConfFile($node);
		writeNodeConfFile($node, $nodeconfiguration);
		$messagetype = "success";
		$message = "Saved Node '".$node."'";
		showMessage($messagetype, $message);
	}
}

if($debug) {
	echo "</td><td>";
	echo "<pre>";
	print_r($nodeconfiguration);
	"</pre>";
	echo "</td></tr></table>";
}

$avail_devices = getAvailableDevices($nodeconfiguration);
$global_devices = getGlobalDevices($nodeconfiguration);
$global_wifi_devices = getGlobalWifiDevices($nodeconfiguration);

/****************************
* Configuration form
*****************************/
echo "<h1>Edit Configuration of Node '$node'</h1>\n";

if($debug) {
	echo "configfile: $configfile";
	echo "<pre>";
	print_r($nodeconfiguration);
	echo "</pre>";
}

echo "<h2>Node Settings</h2>\n";

echo "<form name='formeditnode' action='".$_SERVER['PHP_SELF']."' method='post'>\n";
	echo "<input type='hidden' name='editnode' value='".$node."' />\n";
	echo "<input type='hidden' name='updatingnode' value='1' />\n";


/****************************
* Connection
*****************************/
echo "<fieldset>\n";
echo "<legend>Connection</legend>\n";


echo "<table border='0' class='editnode'>\n";
		echo "<tr>\n";
			echo "<td class='column1'>\n";
				echo "Node is Managementstation:\n";
			echo "</td>\n";
			echo "<td class='column2'>\n";
				echo "<input type='checkbox' name='GLOBAL_MGMT' value='yes' ";
					if($nodeconfiguration['GLOBAL_MGMT'] == "yes") echo "checked='checked'";
				echo "/>\n";
			echo "</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
			echo "<td class='column1'>\n";
				echo "Default Route IPv4:\n";
			echo "</td>\n";
			echo "<td class='column2'>\n";
				echo "Gateway:";
			echo "</td>";
			echo "<td class='column3'>\n";
				echo "<input type='text' name='GLOBAL_GW' value='".$nodeconfiguration['GLOBAL_GW']."'/>\n";
			echo "</td>\n";
			echo "<td class='column4'>\n";
				echo "via interface ";
				echo "<select name='GLOBAL_GW_IF'>";
					if(count($global_devices) == 0) {
						echo "<option value='' selected='selected'>(no if enabled)</option>";
					} else {
						foreach($global_devices as $global_device) {
							echo "<option value='$global_device'";
								if($nodeconfiguration['GLOBAL_GW_IF']==$global_device) echo " selected='selected'";
							echo ">$global_device</option>";
						}
					}
				echo "</select>\n";
			echo "</td>\n";
			echo "<td class='column5'>\n";
				echo "Override by DHCP:\n";
			echo "</td>\n";
			echo "<td class='column6'>\n";
				echo "<input type='checkbox' name='route_dhcp' value='".$_POST['route_dhcp']."' ";
					if($nodeconfiguration[$nodeconfiguration['GLOBAL_GW_IF'] . "_OVERRIDE_ROUTE"] == "yes") echo "checked='checked'";
				echo "/>\n";
			echo "</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
			echo "<td class='column1'>\n";
				echo "Default Route IPv6:\n";
			echo "</td>\n";
			echo "<td class='column2'>\n";
				echo "Gateway:";
			echo "</td>";
			echo "<td class='column3'>\n";
				echo "<input type='text' name='GLOBAL_GW6' value='".$nodeconfiguration['GLOBAL_GW6']."'/>\n";
			echo "</td>\n";
			echo "<td class='column4'>\n";
				echo "via interface ";
				echo "<select name='GLOBAL_GW6_IF'>";
					if(count($global_devices) == 0) {
						echo "<option value='' selected='selected'>(no if enabled)</option>";
					} else {
						foreach($global_devices as $global_device) {
							echo "<option value='$global_device'";
								if($nodeconfiguration['GLOBAL_GW6_IF']==$global_device) echo " selected='selected'";
							echo ">$global_device</option>";
						}
					}
				echo "</select>\n";
			echo "</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
			echo "<td class='column1'>\n";
				echo "DNS:\n";
			echo "</td>\n";
			echo "<td class='column2'>\n";
				echo "Server 0:";
			echo "</td>";
			echo "<td class='column3'>\n";
				echo "<input type='text' name='GLOBAL_DNS0' value='".$nodeconfiguration['GLOBAL_DNS0']."'/>\n";
			echo "</td>";
			echo "<td class='column4'>\n";
			echo "</td>";
			echo "<td class='column5'>\n";
				echo "Override by DHCP:\n";
			echo "</td>\n";
			echo "<td class='column6'>\n";
				echo "<input type='checkbox' name='dns_dhcp' value='".$_POST['dns_dhcp']."' ";
					if($nodeconfiguration[$global_devices[0].'_OVERRIDE_DNS'] == "yes") echo "checked='checked'";
				echo "/>\n";
			echo "</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
			echo "<td class='column1'>\n";
			echo "</td>\n";
			echo "<td class='column2'>\n";
				echo "Server 1:";
			echo "</td>";
			echo "<td class='column3'>\n";
				echo "<input type='text' name='GLOBAL_DNS1' value='".$nodeconfiguration['GLOBAL_DNS1']."'/>\n";
			echo "</td>";
		echo "</tr>\n";
		echo "<tr>\n";
			echo "<td class='column1'>\n";
				echo "Syslog:\n";
			echo "</td>\n";
			echo "<td class='column2'>\n";
				echo "Server:";
			echo "</td>";
			echo "<td class='column3'>\n";
					echo "<input type='text' name='GLOBAL_SYSLOG' value='".$nodeconfiguration['GLOBAL_SYSLOG']."'/>\n";
			echo "</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
			echo "<td class='column1'>\n";
				echo "Lost Timeout (in hours):\n";
			echo "</td>\n";
			echo "<td class='column2'>\n";
				echo "<input type='text' name='GLOBAL_LOSTTIMEOUT' value='".$nodeconfiguration['GLOBAL_LOSTTIMEOUT']."'/>\n";
			echo "</td>";
		echo "</tr>\n";

echo "</table>";
echo "</fieldset>\n";

/****************************
* Cfengine
*****************************/
echo "<fieldset>\n";
echo "<legend>Cfengine</legend>\n";
echo "<table class='editnode'>";
	echo "<tr>\n";
		echo "<td class='column1'>\n";
			echo "Cfengine Device:\n";
		echo "</td>\n";
		echo "<td class='column2'>\n";
			echo "<select name='GLOBAL_CFNET_DEVICE'>";
				if(count($global_wifi_devices) == 0) {
					echo "<option value='' selected='selected'>(no if enabled)</option>";
				} else {
					foreach($global_wifi_devices as $global_wifi_device) {
						echo "<option value='$global_wifi_device'";
							if($nodeconfiguration['GLOBAL_CFNET_DEVICE']==$global_wifi_device) echo " selected='selected'";
						echo ">$global_wifi_device</option>";
					}
				}
			echo "</select>\n";
		echo "</td>\n";
		echo "<td class='column3'>\n";
			echo "its MAC address:\n";
		echo "</td>\n";
		echo "<td class='column4'>\n";
			echo "<input type='text' name='GLOBAL_CFNET_MAC' value='".$nodeconfiguration['GLOBAL_CFNET_MAC']."'/>\n";
		echo "</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
		echo "<td class='column1'>\n";
			echo "Search over\n";
		echo "</td>\n";
		echo "<td class='column2'>\n";
			echo generateNrDropdown(1, 10, 'GLOBAL_CFHOPS', $nodeconfiguration['GLOBAL_CFHOPS']);
			echo "Hops for peers";
		echo "</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
		echo "<td class='column1'>\n";
			echo "Static Peer List\n";
		echo "</td>\n";
		echo "<td class='column2' colspan='2'>\n";
			echo "<input type='text' name='GLOBAL_CFNET_STATIC_PEER_LIST' value='".$nodeconfiguration['GLOBAL_CFNET_STATIC_PEER_LIST']."' style='width: 330px;'/>\n";
		echo "</td>\n";
		echo "<td class='column4' style='width: 530px;'>\n";
			echo "(Separate peer names or ip adresses with spaces)";
		echo "</td>\n";
	echo "</tr>\n";
echo "</table>";
echo "</fieldset>\n";

/****************************
* Adhoc routing
*****************************/
echo "<fieldset>\n";
echo "<legend>Ad-Hoc Routing</legend>\n";
echo "<table class='editnode'>";
	echo "<tr>\n";
		echo "<td class='column1' valign='top'>\n";
			echo "Running Routing Agent on:\n";
		echo "</td>\n";
		echo "<td class='column2'>\n";
			if(count($global_devices) == 0) {
				echo "(no interface enabled)<br>";
			} else {
				foreach($global_devices as $global_device) {
					echo "<input type='checkbox' name='GLOBAL_ADHOCROUTING_DEVICES[]' value='".$global_device."'";
						if(strstr($nodeconfiguration['GLOBAL_ADHOCROUTING_DEVICES'], $global_device)) {
							echo " checked='checked'";
						}
					echo "> $global_device<br>";
				}
			}
		echo "</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
		echo "<td class='column1' valign='top'>\n";
			echo "Adhoc routing protocol:\n";
		echo "</td>\n";
		echo "<td class='column2'>\n";
			echo "<select name='GLOBAL_ADHOCROUTING'>";
				$adhocroutingalgos = array('olsr', 'aodv', 'dsr');
				foreach($adhocroutingalgos as $adhocroutingalgo) {
					echo "<option value='$adhocroutingalgo'";
						if($nodeconfiguration['GLOBAL_ADHOCROUTING']==$adhocroutingalgo) echo " selected='selected'";
					echo ">$adhocroutingalgo</option>";
				}
			echo "</select>\n";

		echo "</td>\n";
	echo "</tr>\n";
echo "</table>";
echo "</fieldset>\n";

/****************************
* NTP
*****************************/
echo "<fieldset>\n";
echo "<legend>NTP</legend>\n";
echo "<table class='editnode'>";
	echo "<tr>\n";
		echo "<td class='column1' valign='top'>\n";
			echo "Is NTP Server:\n";
		echo "</td>\n";
		echo "<td class='column2'>\n";
			echo "<input type='checkbox' name='GLOBAL_NTP_BE_SERVER' value='".$nodeconfiguration['GLOBAL_NTP_BE_SERVER']."' ";
				if($nodeconfiguration['GLOBAL_NTP_BE_SERVER'] == "yes") echo "checked='checked'";
			echo "/>\n";
		echo "</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
		echo "<td class='column1' valign='top'>\n";
			echo "Is NTP Client:\n";
		echo "</td>\n";
		echo "<td class='column2'>\n";
			echo "<input type='checkbox' name='GLOBAL_NTP_BE_CLIENT' value='".$nodeconfiguration['GLOBAL_NTP_BE_CLIENT']."' ";
				if($nodeconfiguration['GLOBAL_NTP_BE_CLIENT'] == "yes") echo "checked='checked'";
			echo "/>\n";
		echo "</td>\n";
		echo "<td class='column3' valign='top'>\n";
			echo "Use a Server pool:\n";
		echo "</td>\n";
		echo "<td class='column4' valign='top'>\n";
			echo "<input type='checkbox' name='GLOBAL_NTP_POOL' value='".$nodeconfiguration['GLOBAL_NTP_POOL']."' ";
				if($nodeconfiguration['GLOBAL_NTP_POOL'] == "yes") echo "checked='checked'";
			echo "/>\n";
		echo "</td>\n";
	echo "</tr>";
	echo "<tr>";
		echo "<td class='column1' valign='top'></td>\n";
		echo "<td class='column2' valign='top'></td>\n";
		echo "<td class='column3' valign='top'>\n";
			echo "Use this Server or pool:\n";
		echo "</td>\n";
		echo "<td class='column4'>\n";
			echo "<input type='text' name='GLOBAL_NTP_SERVER' value='".$nodeconfiguration['GLOBAL_NTP_SERVER']."'/>\n";
		echo "</td>\n";
	echo "</tr>";
	echo "<tr>";
		echo "<td class='column1' valign='top'></td>\n";
		echo "<td class='column2' valign='top'></td>\n";
		echo "<td class='column3'>\n";
			echo "Override by DHCP:\n";
		echo "</td>\n";
		echo "<td class='column6'>\n";
			echo "<input type='checkbox' name='ntp_dhcp' value='".$_POST['ntp_dhcp']."' ";
				if($nodeconfiguration[$global_devices[0].'_OVERRIDE_NTP'] == "yes") echo "checked='checked'";
			echo "/>\n";
		echo "</td>\n";

	echo "</tr>\n";
echo "</table>";
echo "</fieldset>\n";

/****************************
* radvd
*****************************/
echo "<fieldset>\n";
echo "<legend>IPv6 routing advertisement daemon</legend>\n";
echo "<table class='editnode'>";
	echo "<tr>\n";
		echo "<td class='column1' valign='top'>\n";
			echo "Start radvd:\n";
		echo "</td>\n";
		echo "<td class='column2'>\n";
			echo "<input type='checkbox' name='GLOBAL_RADVD_START' value='".$nodeconfiguration['GLOBAL_RADVD_START']."' ";
				if($nodeconfiguration['GLOBAL_RADVD_START'] == "yes") echo "checked='checked'";
			echo "/>\n";
		echo "</td>\n";
	echo "</tr>\n";
echo "</table>";
echo "</fieldset>\n";

/****************************
* ipv4 dhcp
*****************************/
echo "<fieldset>\n";
echo "<legend>IPv4 DHCP Server</legend>\n";
echo "<table class='editnode'>";
	echo "<tr>\n";
		echo "<td class='column1' valign='top'>\n";
			echo "Start DHCP:\n";
		echo "</td>\n";
		echo "<td class='column2'>\n";
			echo "<input type='checkbox' name='GLOBAL_UDHCPD_START' value='".$nodeconfiguration['GLOBAL_UDHCPD_START']."' ";
				if($nodeconfiguration['GLOBAL_UDHCPD_START'] == "yes") echo "checked='checked'";
			echo "/>\n";
		echo "</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";                                                               
		echo "<td class='column1' valign='top'>\n";                          
	                   echo "Only static assignments:\n";                                        
	        echo "</td>\n";                                                      
                echo "<td class='column2'>\n";                                       
                echo "<input type='checkbox' name='GLOBAL_UDHCPD_STATIC_ONLY' value='".$nodeconfiguration['GLOBAL_UDHCPD_STATIC_ONLY']."' ";
                                 if($nodeconfiguration['GLOBAL_UDHCPD_STATIC_ONLY'] == "yes" ) echo "checked='checked'";
                          echo "/>\n";                                                 
                echo "</td>\n";                                                      
                echo "</tr>\n"; 
	echo "<tr>\n";
		echo "<td class='column1' valign='top'>\n";
			echo "Device to listen on:\n";
		echo "</td>\n";
		echo "<td class='column2'>\n";
			echo "<select name='GLOBAL_UDHCPD_DEVICE'>";
				if(count($global_devices) == 0) {
					echo "<option value='' selected='selected'>(no if enabled)</option>";
				} else {
					echo "<option value=''";
						if($nodeconfiguration['GLOBAL_UDHCPD_DEVICE']=='') echo " selected='selected'";
					echo "></option>";
					foreach($global_devices as $global_device) {
						echo "<option value='$global_device'";
							if($nodeconfiguration['GLOBAL_UDHCPD_DEVICE']==$global_device) echo " selected='selected'";
						echo ">$global_device</option>";
					}
				}
			echo "</select>\n";
		echo "</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
		echo "<td class='column1' valign='top'>\n";
			echo "Start IP of the leases pool:\n";
		echo "</td>\n";
		echo "<td class='column2'>\n";
			echo "<input type='text' name='GLOBAL_UDHCPD_LEASE_START' value='".$nodeconfiguration['GLOBAL_UDHCPD_LEASE_START']."'/>\n";
		echo "</td>\n";
	echo "</tr>\n";
	echo "<tr>\n";
		echo "<td class='column1' valign='top'>\n";
			echo "End IP of the leases pool:\n";
		echo "</td>\n";
		echo "<td class='column2'>\n";
			echo "<input type='text' name='GLOBAL_UDHCPD_LEASE_END' value='".$nodeconfiguration['GLOBAL_UDHCPD_LEASE_END']."'/>\n";
		echo "</td>\n";
	echo "</tr>\n";
echo "</table>";
echo "</fieldset>\n";

/****************************
* Netfilter
*****************************/
echo "<fieldset>\n";
echo "<legend>Netfilter (Ipv4/Ipv6</legend>\n";
echo "<table class='editnode'>";
		echo "<tr>\n";
			echo "<td class='column1'>\n";
				echo "Log Netfilter:\n";
			echo "</td>\n";
			echo "<td class='column2'>\n";
				echo "<input type='checkbox' name='NETFILTER_LOG' value='".$nodeconfiguration['NETFILTER_LOG']."' ";
					if($nodeconfiguration['NETFILTER_LOG'] == "yes") echo "checked='checked'";
				echo "/>\n";
			echo "</td>\n";
		echo "</tr>\n";
		echo "<tr><td>&nbsp;</td></tr>\n";
		echo "<tr>";
			echo "<th class='column1'>\n";
			echo "</th>";
			echo "<th class='column2'>\n";
				echo "IPv4\n";
			echo "</th>\n";
			echo "<th class='column3'>\n";
				echo "IPv6\n";
			echo "</th>\n";
		echo "</tr>";
		echo "<tr>\n";
			echo "<td class='column1'>\n";
				echo "Start Netfilter:\n";
			echo "</td>\n";
			echo "<td class='column2'>\n";
				echo "<input type='checkbox' name='NETFILTER_START' value='".$nodeconfiguration['NETFILTER_START']."' ";
					if($nodeconfiguration['NETFILTER_START'] == "yes") echo "checked='checked'";
				echo "/>\n";
			echo "</td>\n";
			echo "<td class='column3'>\n";
				echo "<input type='checkbox' name='NETFILTER6_START' value='".$nodeconfiguration['NETFILTER6_START']."' ";
					if($nodeconfiguration['NETFILTER6_START'] == "yes") echo "checked='checked'";
				echo "/>\n";
			echo "</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
			echo "<td class='column1'>\n";
				echo "Allow Local In TCP:<br>\n";
				echo "<span style='font-size: 75%;'>(Separated by spaces)</span>\n";
			echo "</td>\n";
			echo "<td class='column2' valign='top'>\n";
				echo "<input type='text' name='NETFILTER_ALLOW_LOCAL_IN_TCP' value='".$nodeconfiguration['NETFILTER_ALLOW_LOCAL_IN_TCP']."'/>\n";
			echo "</td>\n";
			echo "<td class='column3' valign='top'>\n";
				echo "<input type='text' name='NETFILTER6_ALLOW_LOCAL_IN_TCP' value='".$nodeconfiguration['NETFILTER6_ALLOW_LOCAL_IN_TCP']."'/>\n";
			echo "</td>\n";
			echo "<td class='column4' valign='top' style='width: 500px;'>\n";
				echo "(The standard ports '22 80 443 5308 5567 8080' shouldn't be removed)\n";
			echo "</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
			echo "<td class='column1'>\n";
				echo "Allow Local In UDP:<br>\n";
				echo "<span style='font-size: 75%;'>(Separated by spaces)</span>\n";
			echo "</td>\n";
			echo "<td class='column2' valign='top'>\n";
				echo "<input type='text' name='NETFILTER_ALLOW_LOCAL_IN_UDP' value='".$nodeconfiguration['NETFILTER_ALLOW_LOCAL_IN_UDP']."'/>\n";
			echo "</td>\n";
			echo "<td class='column3' valign='top'>\n";
				echo "<input type='text' name='NETFILTER6_ALLOW_LOCAL_IN_UDP' value='".$nodeconfiguration['NETFILTER6_ALLOW_LOCAL_IN_UDP']."'/>\n";
			echo "</td>\n";
			echo "<td class='column4' valign='top' style='width: 500px;'>\n";
				echo "(The standard ports '67 123 698 5308 5567 8080 33434:33999' shouldn't be removed)\n";
			echo "</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
			echo "<td class='column1'>\n";
				echo "Allow Forwarding:\n";
			echo "</td>\n";
			echo "<td class='column2'>\n";
				echo "<input type='checkbox' name='NETFILTER_ALLOW_FORWARD' value='".$nodeconfiguration['NETFILTER_ALLOW_FORWARD']."' ";
					if($nodeconfiguration['NETFILTER_ALLOW_FORWARD'] == "yes") echo "checked='checked'";
				echo "/>\n";
			echo "</td>\n";
			echo "<td class='column3'>\n";
				echo "<input type='checkbox' name='NETFILTER6_ALLOW_FORWARD' value='".$nodeconfiguration['NETFILTER6_ALLOW_FORWARD']."' ";
					if($nodeconfiguration['NETFILTER6_ALLOW_FORWARD'] == "yes") echo "checked='checked'";
				echo "/>\n";
			echo "</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
			echo "<td class='column1'>\n";
				echo "Allow Local Out:\n";
			echo "</td>\n";
			echo "<td class='column2'>\n";
				echo "<input type='checkbox' name='NETFILTER_ALLOW_LOCAL_OUT' value='".$nodeconfiguration['NETFILTER_ALLOW_LOCAL_OUT']."' ";
					if($nodeconfiguration['NETFILTER_ALLOW_LOCAL_OUT'] == "yes") echo "checked='checked'";
				echo "/>\n";
			echo "</td>\n";
			echo "<td class='column3'>\n";
				echo "<input type='checkbox' name='NETFILTER6_ALLOW_LOCAL_OUT' value='".$nodeconfiguration['NETFILTER6_ALLOW_LOCAL_OUT']."' ";
					if($nodeconfiguration['NETFILTER6_ALLOW_LOCAL_OUT'] == "yes") echo "checked='checked'";
				echo "/>\n";
			echo "</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
			echo "<td class='column1'>\n";
				echo "SNAT to Interface:\n";
			echo "</td>\n";
			echo "<td class='column2'>\n";
				echo "<select name='NETFILTER_SNAT_TO_IF'>";
					echo "<option value=''";
						if($nodeconfiguration['NETFILTER_SNAT_TO_IF']=="") echo " selected='selected'";
					echo "></option>";
					foreach($global_devices as $global_device) {
						echo "<option value='$global_device'";
							if($nodeconfiguration['NETFILTER_SNAT_TO_IF']==$global_device) echo " selected='selected'";
						echo ">$global_device</option>";
					}
				echo "</select>\n";
			echo "</td>\n";
		echo "</tr>\n";
	echo "</table>\n";
echo "</fieldset>\n";
	
/****************************
* Individual interface settings
*****************************/
	echo "<h2>Interface Settings</h2>\n";
	foreach($avail_devices as $avail_device) {
		echo "<fieldset>\n";
			echo "<legend>Interface $avail_device</legend>\n";
			echo "<table class='editnode'>";
				echo "<tr>\n";
					echo "<td class='column1'>\n";
						echo "Configuration:\n";
					echo "</td>\n";
					echo "<td class='column2'>\n";
						echo "<select name='".$avail_device."_config_mode' onChange='submit();'>";
							echo "<option value='disabled' ";
								if(!in_array($avail_device, $global_devices)) echo "selected='selected'";
							echo ">Disabled</option>";
							echo "<option value='dhcp' ";
								if($nodeconfiguration[$avail_device.'_DHCP'] == 'yes') echo "selected='selected'";
							echo ">DHCP</option>";
							echo "<option value='manual' ";
								if($nodeconfiguration[$avail_device.'_DHCP'] == 'no') echo "selected='selected'";
							echo ">Manual</option>";
						echo "</select>\n";
					echo "</td>\n";
				echo "</tr>\n";
			echo "</table>";
			if(in_array($avail_device, $global_devices)) {
				if($nodeconfiguration[$avail_device.'_DHCP'] == 'no') {
					echo "<fieldset class='level2'>";
					echo "<legend>IP settings</legend>\n";
						echo "<table class='editnode'>";
							echo "<tr>";
								echo "<td class='column1'>\n";
									echo "RADVD Prefix:";
								echo "</td>";
								echo "<td class='column2'>\n";
									echo "<input type='text' name='".$avail_device."_RADVD_PREFIX' value='".$nodeconfiguration[$avail_device.'_RADVD_PREFIX']."' />\n";
								echo "</td>\n";
							echo "</tr>";
							echo "<tr>";
								echo "<th class='column1'>\n";
								echo "</th>";
								echo "<th class='column2'>\n";
									echo "IPv4\n";
								echo "</th>\n";
								echo "<th class='column3'>\n";
									echo "IPv6\n";
								echo "</th>\n";
							echo "</tr>";
							echo "<tr>";
								echo "<td class='column1'>\n";
									echo "IP Address:";
								echo "</td>";
								echo "<td class='column2'>\n";
									echo "<input type='text' name='".$avail_device."_IP' value='".$nodeconfiguration[$avail_device.'_IP']."' />\n";
								echo "</td>\n";
								echo "<td class='column3' style='width: 400px;'>\n";
									echo $nodeconfiguration['GLOBAL_CFNET_PREFIX']." <input type='text' name='".$avail_device."_IP6' value='".$nodeconfiguration[$avail_device.'_IP6']."' />\n";
								echo "</td>\n";
							echo "</tr>";
							echo "<tr>";
								echo "<td class='column1'>\n";
									echo "Netmask:";
								echo "</td>";
								echo "<td class='column2'>\n";
									echo generateNrDropdown(0, 32, $avail_device.'_MASK', $nodeconfiguration[$avail_device.'_MASK'], true);
								echo "</td>\n";
								echo "<td class='column3'>\n";
									echo generateNrDropdown(0, 128, $avail_device.'_MASK6', $nodeconfiguration[$avail_device.'_MASK6'], true);
								echo "</td>\n";
							echo "</tr>";
							echo "<tr>";
								echo "<td class='column1'>\n";
									echo "Domain:";
								echo "</td>";
								echo "<td class='column2'>\n";
									echo "<input type='text' name='".$avail_device."_DOMAIN' value='".$nodeconfiguration[$avail_device.'_DOMAIN']."' />\n";
								echo "</td>\n";
								echo "<td class='column3'>\n";
									echo "<input type='text' name='".$avail_device."_DOMAIN6' value='".$nodeconfiguration[$avail_device.'_DOMAIN6']."' />\n";
								echo "</td>\n";
							echo "</tr>";
						echo "</table>";
					echo "</fieldset>";
				}
				if(in_array($avail_device, $global_wifi_devices)) {
					echo "<fieldset class='level2'>";
					echo "<legend>WIFI Settings</legend>\n";
						echo "<table class='editnode'>";
							echo "<tr>";
								echo "<td class='column1'>\n";
									echo "ESSID:";
								echo "</td>";
								echo "<td class='column2'>\n";
									echo "<input type='text' name='".$avail_device."_ESSID' value='".$nodeconfiguration[$avail_device.'_ESSID']."'/>\n";
								echo "</td>\n";
							echo "</tr>";
							echo "<tr>";
								echo "<td class='column1'>\n";
									echo "Standard:";
								echo "</td>";
								echo "<td class='column2'>\n";
									echo generateWlanStandardDropdown($avail_device."_STANDARD", $nodeconfiguration[$avail_device.'_STANDARD']);
								echo "</td>\n";
							echo "</tr>";
							echo "<tr>";
								echo "<td class='column1'>\n";
									echo "Outdoor usage:";
								echo "</td>";
								echo "<td class='column2'>\n";
									echo "<input type='checkbox' name='".$avail_device."_OUTDOOR' value='".$nodeconfiguration[$avail_device.'_OUTDOOR']."' ";
									if($nodeconfiguration[$avail_device.'_OUTDOOR'] == "yes") echo "checked='checked'";
									echo "/>\n";
								echo "</td>\n";
							echo "</tr>";
							echo "<tr>";
								echo "<td class='column1'>\n";
									echo "Country Code:";
								echo "</td>";
								echo "<td class='column2'>\n";
									echo generateCountryCodeDropdown($avail_device."_COUNTRY_CODE", $nodeconfiguration[$avail_device.'_COUNTRY_CODE']);
								echo "</td>\n";
							echo "</tr>";
							echo "<tr>";
								echo "<td class='column1'>\n";
									echo "TXPower:";
								echo "</td>";
								echo "<td class='column2'>\n";
									echo "<input type='text' name='".$avail_device."_TXPOWER' value='".$nodeconfiguration[$avail_device.'_TXPOWER']."'/>\n";
								echo "</td>\n";
								echo "<td class='column3' style='width: 300px;'>\n";
									echo "(pos. integer in mW or 'auto')";
								echo "</td>";

							echo "</tr>";
							echo "<tr>";
								echo "<td class='column1'>\n";
									echo "Max Legal TXPower:";
								echo "</td>";
								echo "<td class='column2'>\n";
									echo "<input type='text' name='".$avail_device."_MAX_LEGAL_POWER' value='".$nodeconfiguration[$avail_device.'_MAX_LEGAL_POWER']."'/>\n";
								echo "</td>\n";
								echo "<td class='column3' style='width: 300px;'>\n";
									echo "(pos. integer in mW or empty)";
								echo "</td>";
							echo "</tr>";
						echo "</table>";
					echo "</fieldset>";
				}
			}
		echo "</fieldset>\n";
	}
	echo "<br />";
	echo "<input type='submit' name='save' value='Save' class='button'/>\n";
	echo "<input type='reset' name='cancel' value='Cancel' onClick='location.href=\"configuration.php\"' class='button'/>\n";
	echo "<br />";
	echo "<br />";


echo "</form>\n";

require_once('../includes/footer.php');

function checkForm() {
	$error = "";
	if(!isValidIp($_POST['GLOBAL_GW']) && $_POST['GLOBAL_GW'] != "") {
		$error .= "Invalid IPv4 Gateway IP<br />";
	}
	if(!isValidIp($_POST['GLOBAL_SYSLOG']) && $_POST['GLOBAL_SYSLOG'] != "") {
		$error .= "Invalid Syslog IP<br />";
	}
	return $error;
}

function isValidIp($ip) {
	$val_0_to_255 = "(25[012345]|2[01234]\d|[01]?\d\d?)";
	$pattern = "#^($val_0_to_255\.$val_0_to_255\.$val_0_to_255\.$val_0_to_255)$#";
	return preg_match($pattern, $ip, $matches);
}

?>

