<?php

/****************************
* Managing networks, configurations, image-updates
*****************************/

require_once('../includes/functions.php');
require_once('../includes/includes.php');

showMessage($messagetype, $message);
$actualconfig = getActualConfigName();

/****************************
* Actions, depending on clicked buttons
*****************************/

if(isset($_POST['loadFromNetwork'])) {
	loadConfigsFromNetwork($_POST['loadFromNetworkConfigName']);
	$messagetype = "success";
	$message = "Loaded deployed Network Configuration as '".$_POST['loadFromNetworkConfigName']."'\n";
	$actualconfig = getActualConfigName();
}
if(isset($_POST['loadFromUSB'])) {
	loadConfigsFromUSB($_POST['loadconfig']);
	$messagetype = "success";
	$message = "Configuration '".$_POST['loadconfig']."' loaded\n";
	$actualconfig = getActualConfigName();
}
if(isset($_POST['save'])) {
	saveConfigToUSB();
	$messagetype = "success";
	$message = "Configuration '".$actualconfig."' saved to USB-Stick\n";

}
if (isset($_POST['discard'])) {
	discardActualConfig();
	$messagetype = "success";
	$message = "Configuration ".$_POST['configname']." discarded\n";
	$actualconfig="";
}
if (isset($_POST['generateImages'])) {
	generateImages();
	$messagetype = "success";
	$message = "Images of Configuration '".$_POST['configname']."' generated\n";
}

if(isset($_POST['uploadImage'])) {

	if(($returnvalue = distributeNewImage()) == ""){
		$messagetype = "success";
		$message = "Uploaded new Image '".$_POST['newImageTxt']."'.\n";
	} else {
		$messagetype = "error";
		$message = $returnvalue;
	}
}
if(isset($_POST['uploadCommand'])) {

	if(($returnvalue = uploadCommand()) == ""){
		$messagetype = "success";
		$message = "Uploaded new Command '".$_POST['newCommandTxt']."'.\n";
	} else {
		$messagetype = "error";
		$message = $returnvalue;
	}
}

if(isset($_POST['deploy'])) {
	global $config;
	
	if(deployActualConfiguration()) {
		$messagetype = "success";
		$message = "Deployed current Networkconfiguration.\n";
	} else {
		$messagetype = "error";
		$message = "Couldn't deploy current Networkconfiguration.\n";
	}
}

if(isset($_POST['stopImageDistribution'])) {
	if(($returnvalue = stopImageDistribution()) == ""){
		$messagetype = "success";
		$message = "Distribition finished\n";
	} else {
		$messagetype = "error";
		$message = $returnvalue;
	}
}



require('../includes/header.php');

showMessage($messagetype, $message);

echo "<h1>Configuration Management</h1>\n";

echo "<form action='".$_SERVER['PHP_SELF']."' name='configManagement' method='post'>\n";

/****************************
* Deployed network
*****************************/
echo "<fieldset>\n";
	echo "<legend>Deployed Network Configuration</legend>\n";
	$deployedNodes = getDeployedNodes();
	if(count($deployedNodes) == 0) {
		echo "No Network Configuration deployed";
	} else {
		echo "<ul>";
		foreach($deployedNodes as $node) {
			$path_parts = pathinfo($node);
			echo "<li>".$path_parts['filename']."</li>";
		}
		echo "</ul>";
	}
	
echo "</fieldset>\n";

	echo "<div style='display: block;border: 0px solid red;height: 48px; margin: 20px;'>";
		if(count($deployedNodes) > 0) {
			echo "<div style='position:absolute; left:50px; height: 48px;border:0px solid green;'>";
				echo "<img src='/pics/down.png' border='0' style='float: left;'/>";
				echo "<input type='submit' class='button' name='loadFromNetwork' value='Load' style='margin-top: 14px; margin-left: 10px; float:left;'/>";
				echo "<div style='float:left; height: 48px; vertical-align: middle; line-height:48px; margin-left:10px;'> as </div>";
				echo "<input type='text' name='loadFromNetworkConfigName' value='config01' style='margin-top: 14px; margin-left: 10px;' />";
			echo "</div>";
		}
		if (getActualConfigName() != "") {
			echo "<div style='position:absolute; right:50px; height: 48px; border: 0px solid green; text-align: right;'>";
				echo "<input type='submit' class='button' name='deploy' value='Deploy' style='margin-top: 14px; margin-right: 10px;float: left;'/>";
				echo "<img src='/pics/up.png' border='0' />";
			echo "</div>";
		}
	echo "</div>";
echo "</form>\n";

/****************************
* Current configuration
*****************************/
echo "<fieldset class='spezial'>\n";
	echo "<legend>Current Configuration</legend>\n";
	echo "<form name='configselection' action='configuration.php' enctype='multipart/form-data' method='post'>\n";
		echo "<table class='setup'>\n";
			echo "<tr>\n";
				echo "<td class='column1'>\n";
					echo "Current Configuration:\n";
				echo "</td>\n";
				echo "<td class='column2'>\n";
					if (getActualConfigName() == "") {
						echo "No Configuration loaded\n";
					} else {
						echo getActualConfigName() . "\n";
					}
				echo "</td>\n";
				echo "<td class='column3'>\n";
					echo "<input type='hidden' name='configname' value='".$actualconfig."'/>\n";
					if (!strlen($actualconfig) == 0) {
						echo "<input type='submit' name='edit' value='Edit' class='button'/>\n";
						echo "<input type='submit' name='discard' value='Discard' onClick='setAction(\"configselection\",\"setup.php\");' class='button'/>\n";
						echo "<input type='submit' name='generateImages' value='Generate Configuration Archive' onClick='setAction(\"configselection\",\"setup.php\");' class='button' style='width: 220px;'/>\n";
					}
				echo "</td>\n";
			echo "</tr>\n";
			echo "<tr>\n";
				echo "<td class='column1'>\n";
					echo "Create New Configuration:\n";
				echo "</td>\n";
				echo "<td class='column2'>\n";
					echo "<input type='text' name='newconfigname' value='config01' />\n";
				echo "</td>\n";
				echo "<td class='column3'>\n";
					echo "<input type='submit' name='create' class='button' value='Create' />\n";
				echo "</td>\n";
			echo "</tr>\n";
		echo "</table>";
	echo "</form>";
echo "</fieldset>\n";


$configdevice="";
$usbstickavailable = false;
if(is_dir($config['folderUSBNodeConfiguration'])) {
	$usbstickavailable = true;
} else {
	shell_exec('sudo /sbin/umountconfig 2>&1');
	shell_exec('sudo /sbin/mountconfig 2>&1');
	if (is_dir($config['folderUSBNodeConfiguration'])) {
		$usbstickavailable = true;
	}
}
if($usbstickavailable) {
	$savedconfigs=getSavedConfigNames($configdir);
}

/****************************
* Configurations on USB Stick
*****************************/
echo "<form action='".$_SERVER['PHP_SELF']."' method='post'>\n";
	echo "<div style='display: block;border: 0px solid red;height: 48px; margin: 20px;'>";
		if($usbstickavailable) {
			echo "<div style='position:absolute; left:50px; height: 48px;border:0px solid green;'>";
				echo "<img src='/pics/down.png' border='0' style='float: left;'/>";
				echo "<input type='submit' class='button' name='save' value='Save' style='margin-top: 14px; margin-left: 10px;'/>";	
			echo "</div>";
			echo "<div style='position:absolute; right:50px; height: 48px; border: 0px solid green; text-align: right;'>";
				echo "<input type='submit' class='button' name='loadFromUSB' value='Load' style='margin-top: 14px; margin-right: 10px;float: left;'/>";
				echo "<img src='/pics/up.png' border='0' />";
			echo "</div>";
		}
	echo "</div>";

	echo "<fieldset>\n";
		echo "<legend>Saved Configurations (USB-Stick)</legend>\n";
		if($usbstickavailable) {
			echo "<table class='setup'>";
				echo "<tr>\n";
					echo "<td class='column1'>\n";
						echo "Available Configurations:\n";
					echo "</td>\n";
					echo "<td class='column2'>\n";
						echo generateAvailableConfigsDropDown($savedconfigs, $actualconfig);
					echo "</td>\n";
				echo "</tr>\n";
			echo "</table>";
		} else {
			echo "<table class='setup'>\n";
				echo "<tr>\n";
					echo "<td class='column1'>\n";
						echo "No device found.\n";
					echo "</td>\n";
					echo "<td class='column'>\n";
						echo "<input type='submit' class='button' name='mount' value='Mount' /> a previously inserted USB storage device.\n";
					echo "</td>\n";
				echo "</tr>\n";
			echo "</table>\n";
		}
	echo "</fieldset>\n";
echo "</form>";
echo "<br />";
echo "<br />";
echo "<hr>";

/****************************
* Updating Kernel Image
*****************************/
echo "<h1>Updating Kernel Images</h1>\n";

$updatefile = $config['imageUpdateFolder'] . "update";
if(!file_exists($updatefile) || filesize($updatefile) == 0) {
	echo "<form action='".$_SERVER['PHP_SELF']."' enctype='multipart/form-data' name='uploadingImage' method='post'>\n";
		echo "<table class='setup'>\n";
			echo "<tr>\n";
				echo "<td class='column1'>\n";
					echo "Upload new Image:\n";
				echo "</td>\n";
				echo "<td class='column2' style='width: 300px;'>\n";
					echo "<div style='position: relative'>";
						echo "<input type='file' name='newImage' onChange='HandleImageFileButtonClick();' style='position: relative; text-align: right;-moz-opacity:0;filter:alpha(opacity: 0);opacity: 0;z-index: 2;'/>\n";
						echo "<div style='position: absolute; top: 0px; left: 0px; z-index: 1;'>";
							echo "<input type='text' name='newImageTxt' style='width: 190px;'/>\n";
							echo "<input type='button' class='button' name='chooseFile' value='Choose File...'  onclick='HandleImageFileButtonClick();' />";
						echo "</div>";
					echo "</div>";
				echo "</td>\n";
				echo "<td class='column3'>\n";
					echo "<input type='submit' class='button' name='uploadImage' value='Upload' />";
				echo "</td>\n";
			echo "</tr>\n";
		echo "</table>";
	echo "</form>";
} else {
	echo "<form action='".$_SERVER['PHP_SELF']."' name='stopImageDistribution' method='post'>\n";
		echo "<table class='setup'>\n";
			echo "<tr>\n";
				echo "<td>\n";
					echo "<span style='color: red; font-weight: bold'>Distribution of a new image in progress</span>";
				echo "</td>\n";
				echo "<td>\n";
					echo "<input type='submit' class='button' style='width: 200px; margin-left: 20px;' name='stopImageDistribution' value='Distribution finished' />";
				echo "</td>\n";
			echo "</tr>\n";
		echo "</table>";
	echo "</form>";
}

echo "<br /><br />";

/****************************
* Uploading Command scripts
*****************************/
echo "<h1>Uploading Command Script</h1>";

echo "<form action='".$_SERVER['PHP_SELF']."' enctype='multipart/form-data' name='uploadingCommand' method='post'>\n";
	echo "<table class='setup'>\n";
		echo "<tr>\n";
			echo "<td class='column1'>\n";
				echo "Command File:\n";
			echo "</td>\n";
			echo "<td class='column2' style='width: 300px;'>\n";
				echo "<div style='position: relative'>";
					echo "<input type='file' name='newCommand' onChange='HandleCommandFileButtonClick();' style='position: relative; text-align: right;-moz-opacity:0;filter:alpha(opacity: 0);opacity: 0;z-index: 2;'/>\n";
					echo "<div style='position: absolute; top: 0px; left: 0px; z-index: 1;'>";
						echo "<input type='text' name='newCommandTxt' style='width: 190px;'/>\n";
						echo "<input type='button' class='button' name='chooseFile' value='Choose File...'  onclick='HandleCommandFileButtonClick();' />";
					echo "</div>";
				echo "</div>";
			echo "</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
			echo "<td class='column1'>\n";
				echo "Data File:\n";
			echo "</td>\n";
			echo "<td class='column2' style='width: 300px;'>\n";
				echo "<div style='position: relative'>";
					echo "<input type='file' name='newCommandData' onChange='HandleCommandDataFileButtonClick();' style='position: relative; text-align: right;-moz-opacity:0;filter:alpha(opacity: 0);opacity: 0;z-index: 2;'/>\n";
					echo "<div style='position: absolute; top: 0px; left: 0px; z-index: 1;'>";
						echo "<input type='text' name='newCommandDataTxt' style='width: 190px;'/>\n";
						echo "<input type='button' class='button' name='chooseFile' value='Choose File...'  onclick='HandleCommandDataFileButtonClick();' />";
					echo "</div>";
				echo "</div>";
			echo "</td>\n";
		echo "</tr>\n";
		echo "<tr>\n";
			echo "<td class='column1'>\n";
			echo "</td>\n";
			echo "<td class='column2' style='width: 300px;'>\n";
				echo "<input type='submit' class='button' name='uploadCommand' value='Upload' />";
			echo "</td>\n";
		echo "</tr>\n";
	echo "</table>";
echo "</form>";


require('../includes/footer.php');

function generateAvailableConfigsDropDown($savedconfigs, $actualconfig) {
	$string = "";
	$string .= "<select name='loadconfig'>\n";
	for ($i=0;$i<count($savedconfigs);$i++) {
		$string .= "<option value='".$savedconfigs[$i]."'";
			if($savedconfigs[$i] == $actualconfig)
				$string .= " selected='selected'";
		$string .= ">".$savedconfigs[$i]."</option>";
	}
	$string .= "</select>\n";
	return $string;
}

/****************************
* Generating <configname>.tar.gz with configs and keys
*****************************/
function generateImages() {
	global $config;
	$configdir = $config['folderTmpNodeConfiguration'];
	$configname = $_POST['configname'];
        $archive = "";
	$archivecommand = "cd $configdir && tar -czvf - ./$configname >&1";
	$archive = shell_exec("$archivecommand");

	header("Content-Type: application/gzip");
	header("Content-Disposition: attachment; filename=".$configname.".tar.gz;" );
	header("Content-Transfer-Encoding: binary");
	header("Refresh: 0; setup.php");

        echo $archive;
	exit;
}


function deleteDeployedNodes() {
	global $config;
	$deployedNodes = getDeployedNodes();
	if(count($deployedNodes) == 0) {
		return true;
	}
	foreach($deployedNodes as $deployedNode) {
		$deletingConfig = $config['folderDeployedNodeConfiguration'] . $deployedNode;
		if(is_file($deletingConfig) && is_writable($deletingConfig)) {
			unlink($deletingConfig);
		} else {
			return false;
		}
	}
	return true;

}

/****************************
* Deploying current configuration to network
*****************************/
function deployActualConfiguration() {
	global $config;
	$actualconfig = getActualConfigName();
	$hostname = trim(file_get_contents($config['fileHostname']));
	$networkconf = $config['fileNetworkConf'];
	$newPubKeyFolder = $config['folderNewPubKey'];

	$configdir = $config['folderTmpNodeConfiguration'];
	$deployedNodeConfigurationDir = $config['folderDeployedNodeConfiguration'];
	$testNodeConfigurationDir = $config['folderTestNodeConfiguration'];
	$domain = trim(file_get_contents("/etc/conf.d/domainname"));

	$files = scandir($configdir . $actualconfig);
	$command_conf = "sudo /bin/chown httpd:httpd $deployedNodeConfigurationDir*.conf";
        $command_pub = "sudo /bin/chown httpd:httpd $newPubKeyFolder";
        $command_conf_undo = "sudo /bin/chown root:root $deployedNodeConfigurationDir*.conf";
        $command_pub_undo = "sudo /bin/chown -R root:root $newPubKeyFolder";
        exec($command_conf);
        exec($command_pub);
        foreach($files as $file) {
		$path_parts = pathinfo($file);
		if(is_file($configdir . $actualconfig . "/" . $file)) {
 			if($path_parts['extension'] == "conf") {
				if(!copy($configdir . $actualconfig . "/" . $file, $deployedNodeConfigurationDir . $file)) {
					return false;
				}
			} else if($path_parts['extension'] == "pub" && file_exists($configdir . $actualconfig . "/" . $path_parts['filename'] . ".priv")) {
				//add domainname to public-key-name if its a new key
				if (strpos($path_parts['filename'], $domain) === false) {
					if(!copy($configdir . $actualconfig . "/" . $file, $newPubKeyFolder . $path_parts['filename'] . ".$domain.pub")) {
						return false;
					}
				} else {
					if(!copy($configdir . $actualconfig . "/" . $file, $newPubKeyFolder . $file)) {
						return false;
					}
				}
			}
		}
	}
 	exec($command_conf_undo);
        exec($command_pub_undo);
	return true;
}



?>