<?php
/****************************
* Managing the connections to the different sqlite2 databases
*****************************/
	class Db {
		public static $pathToSqliteDbs = "/mnt/state/adam/db/";
		private static $instance = NULL;
		private $wsnDb;
		private $pvDb;
		private $dbs = array();

		private function __construct() {
			$host = trim(getHostname());
			$this->getDB("wsn_".$host);
			$this->getDB("pv_".$host);
		}

		public static function getInstance() {
			if (self::$instance === NULL) {
				self::$instance = new Db;
			}
			return self::$instance;
		}

		private function __clone() {}
		
		public function getWsnDb($host = "") {
			if($host == "") {
				$host = trim(getHostname());
			}
			$db = $this->getDB("wsn_".$host);
			if($db == false) {
				$host = trim(getHostname());
				$db = $this->getDB("wsn_".$host);
			}
			if($db == null) return false;
			return $db;
		}
		public function getPvDb() {

			$db = $this->getDB("pv");
			if(!db) return false;
			return $db;
		}

		private function getDB($dbname) {
			$filepath = self::$pathToSqliteDbs . $dbname . ".db";
			if(is_file($filepath)) {
				if(!array_key_exists($dbname, $this->dbs)) {
					$this->dbs[$dbname] = sqlite_open($filepath);
				}
				return $this->dbs[$dbname];
			} else {
				return false;
			}
		}
	}
