<?php
/****************************
* Meshnode Class (used for network graph and tree)
*****************************/

	class Meshnode {
		public $name;
		public $type;
		public $neighbours = array();
		public $informations = array();
		public $connectedSensornodes = array();
		public $x;
		public $y;
		public $z;
		
		public function __construct($name, $type = "alix") {
			global $config;
			if($name == "") {
				throw new Exception('Meshnodename needed');
			}
			$this->name = $name;
			$this->x = 0;
			$this->y = 0;
			$this->z = 0;
			
			$types = array("alix", "meraki");
			$random = substr($name, -1, 1)%2;
  			$type = $types[$random];
			if(substr($name, 0, 4) == "alix") $type = "alix";
			if(substr($name, 0, 6) == "meraki") $type = "meraki";

			$networkconfigdir = $config['folderDeployedNodeConfiguration'];
			$filename = $networkconfigdir . "/" . $name . ".conf";
			if(is_file($filename)) {
				$filecontent = explodeConfigArray($filename);
				$ip = $filecontent['ath0_IP'];
				$type = $filecontent['GLOBAL_SYSTYPE'];
			}
  			$this->type = $type;
		}
		
		public function updateNeighbours($mn = "") {
			
			$db = Db::getInstance()->getWsnDb($mn);
			if (!$db) die ("DB konnte nicht geöffnet werden.");
			$query = "SELECT * FROM meshnode_network WHERE mn_id = '".$this->name."';";
			$res = sqlite_query($db, $query);
			while ($row = sqlite_fetch_array($res)) {
				$this->neighbours[] = new Meshnode($row['mn_neighbor_id']);
			}
		}
		
		public function getNeighbours($mn = "") {
			$this->neighbours = array();
			$this->updateNeighbours($mn);
			
			return $this->neighbours;
		}
		
		public function updateInformations($mn = "") {
			
		}
		
		public function getInformations($mn = "") {
			$this->updateInformations($mn);
			return $this->informations;
		}

		public function getConnectedSensornodeGateways($mn = "") {
			
			$connectedSensornodeGateways = array();

			$db = Db::getInstance()->getWsnDb($mn);
			if (!$db) die ("DB konnte nicht geöffnet werden.");

			$query = "SELECT * FROM sensornodes WHERE prop_id = '24' AND value = '".$this->name."' AND sn_id IN (SELECT sn_id FROM sensornodes WHERE prop_id = '28' AND value = '1');";
			$res = sqlite_query($db, $query);
			while ($row = sqlite_fetch_array($res)) {
				$connectedSensornodeGateways[] = $row['sn_id'];
			}
			return $connectedSensornodeGateways;
		}
		
		public function getConnectedSensornodes($mn = "") {
			$connectedSensornodes = array();
			$db = Db::getInstance()->getWsnDb($mn);
			if (!$db) die ("DB konnte nicht geöffnet werden.");

			$query = "SELECT * FROM sensornodes WHERE prop_id = '24' AND value = '".$this->name."';";
			$res = sqlite_query($db, $query);
			while ($row = sqlite_fetch_array($res)) {
				$connectedSensornodes[] = new Sensornode($row['sn_id']);
			}
			return $connectedSensornodes;
			
		}

		public function getSensornodeConnections($mn = "") {

			$connections = array();

			$db = Db::getInstance()->getWsnDb($mn);
			if (!$db) die ("DB konnte nicht geöffnet werden.");

			$query = "SELECT * FROM sensornode_network WHERE sn_id IN (SELECT sn_id FROM sensornodes WHERE prop_id = '24' AND value = '".$this->name."') OR sn_neighbor_id IN (SELECT sn_id FROM sensornodes WHERE prop_id = '24' AND value = '".$this->name."');";
			$res = sqlite_query($db, $query);
			while ($row = sqlite_fetch_array($res)) {
				$connections[] = array($row['sn_id'] => $row['sn_neighbor_id']);
			}
			return $connections;
		}

		public function checkIfSensornodeInArray($connectedSensornodes, $sensornode) {
			foreach($connectedSensornodes as $connectedSensornode) {
				if($connectedSensornode == $sensornode) return true;
			}
			return false;
		}
		
		
		public function __toString() {
			$string = "";
			$this->getNeighbours();
			$name = $this->name;
			$nameid = "table" . $name;
			$string .= "<div id=\"$nameid\" class=\"meshnode\" onmouseover=\"showNodeBorder('$name');\" onmouseout=\"showNoNodeBorder('$name');\">\n";
			$string .= "<table>\n";
				$string .= "<tr><td>Name:</td><td>$this->name</td><tr>\n";
				for($i=1; $i<=count($this->neighbours); $i++) {
					$neighbour = $this->neighbours[$i-1];
					$string .= "<tr><td>Neighbour $i:</td><td>$neighbour->name</td><tr>\n";
				}
			$string .= "</table>\n";
			$string .= "</div>";
			return $string;
		}
	}
?>