<?php
/****************************
* Network Class  (used for network graph and tree)
*****************************/
	class Network {
		public $name;
		public $startMeshnode;
		public $meshnodes = array();
		public $connections = array();
		public $sensornodes = array();
		public $snMnConnections = array();
		public $snSnConnections = array();
		
		public function __construct($name, $startMeshnode) {
			if($name == "" || $startMeshnode == null) {
				throw new Exception('Name and startMeshnode needed');
			}
			$this->name = $name;
			$this->startMeshnode = $startMeshnode;
		}
		
		public function getAllMeshnodes() {
			$this->meshnodes = array();
			$db = Db::getInstance()->getWsnDb();
			if (!$db) die ("DB konnte nicht geöffnet werden.");
			$res = sqlite_query($db, "SELECT * FROM 'meshnodes';");
			while ($row = sqlite_fetch_array($res)) {
				$mn = new Meshnode($row['mn_id']);
				$mn->x = $row['x'];
				$mn->y = $row['y'];
				$mn->z = $row['z'];
				$this->meshnodes[] = $mn;
			}
			return $this->meshnodes;
		}

		public function getAllSensornodeGateways() {
			$this->sensornodes = array();
			foreach($this->meshnodes as $meshnode) {
				$db = Db::getInstance()->getWsnDb($meshnode->name);
				if (!$db) die ("DB konnte nicht geöffnet werden.");
	
				$query = "SELECT * FROM sensornodes WHERE prop_id = '24' AND sn_id IN (SELECT sn_id FROM sensornodes WHERE prop_id = '28' AND value = '1')";
				$res = sqlite_query($db, $query);
				while ($row = sqlite_fetch_array($res)) {
					if(!in_array($row['sn_id'], $this->sensornodes)) {
						$this->sensornodes[] = $row['sn_id'];
					}
				}
			}
			print_r($this->sensornodes);
			return $this->sensornodes;
			
		}

		public function getAllConnections() {
			$this->connections = array();
			$db = Db::getInstance()->getWsnDb();
			$res = sqlite_query($db, "SELECT * FROM 'meshnode_network';");
			while ($row = sqlite_fetch_array($res)) {
				$this->connections[] = array($row['mn_id'] => $row['mn_neighbor_id']);
			}
			return $this->connections;
		}

		public function getAllSnMnConnections() {
			$this->snMnConnections = array();
			$db = Db::getInstance()->getWsnDb();
			if (!$db) die ("DB konnte nicht geöffnet werden.");
			$query = "SELECT * FROM sensornodes WHERE prop_id = '24' AND sn_id IN (SELECT sn_id FROM sensornodes WHERE prop_id = '28' AND value = '1')";
			$res = sqlite_query($db, $query);
			while ($row = sqlite_fetch_array($res)) {
				$this->snMnConnections[] = array($row['sn_id'] => $row['value']);
			}
			return $this->snMnConnections;
		}

		public function getAllSnSnConnections() {
			$this->snSnConnections = array();
			$db = Db::getInstance()->getWsnDb();
			if (!$db) die ("DB konnte nicht geöffnet werden.");
			$res = sqlite_query($db, "SELECT * FROM sensornode_network;");
			while ($row = sqlite_fetch_array($res)) {
				$this->snSnConnections[] = array($row['sn_id'] => $row['sn_neighbor_id']);
			}
			return $this->snSnConnections;
		}
		
		private function getRecMeshnodes($meshnode) {
			if(!$this->checkIfMeshnodeInArray($this->meshnodes, $meshnode)) {
				$this->meshnodes[] = $meshnode;
			}				
			$neighbours = $meshnode->getNeighbours();
			foreach($neighbours as $neighbour) {
				if($this->checkIfMeshnodeInArray($this->meshnodes, $neighbour)) {
					continue;
				} else {
					$this->getRecMeshnodes($neighbour);
				}
			}
		}
		
		private function checkIfMeshnodeInArray($array, $testmeshnode) {
			foreach($array as $meshnode) {
				if($meshnode->name == $testmeshnode->name) {
					return true;
				}
			}
			return false;
		}
	}
?>
