<?php
/****************************
* Positioning the nodes on the 3d map
*****************************/

class Positioner {
	public $meshnodes = array();

	public function __construct() {

	}
	
	public function printMeshnodeTable() {

		global $config;
		$this->meshnodes = $this->getMeshnodesFromDb();
		echo "<form name='positions' method='post'>";
		echo "<table class='nodeadjustment'>";
			echo "<tr>";
				echo "<th class='first'>Meshnode</th>";
				echo "<th>X</th>";
				echo "<th>Y</th>";
				echo "<th>Z</th>";
			echo "</tr>";
			foreach($this->meshnodes as $meshnode) {
				echo "<tr>";
					echo "<td>".$meshnode['name']."</td>";
					echo "<td><input type='text' name='".$meshnode['name']."_x' value='".$meshnode['x']."' onkeypress='return isNumberKey(event);'></td>";
					echo "<td><input type='text' name='".$meshnode['name']."_y' value='".$meshnode['y']."' onkeypress='return isNumberKey(event);'></td>";
					echo "<td><input type='text' name='".$meshnode['name']."_z' value='".$meshnode['z']."' onkeypress='return isNumberKey(event);'></td>";
				echo "</tr>";
			}
		echo "</table>";
		echo "<br>";
		echo "Info: Enter data in meters<br><br>";
		echo "Building length (X): ".$config['building_x_m']."m<br>";
		echo "Building width (Y): ".$config['building_y_m']."m<br>";
		echo "Floor height (Z): ".$config['building_z_m']."m<br><br>";
		echo "<input type='submit' name='update' value='Update Positions'>";
		echo "</form>";
	}

	public function getMeshnodesFromDb() {
		$meshnodes = array();
		$db = Db::getInstance()->getWsnDb();
		if (!$db) die ("DB konnte nicht geöffnet werden.");
		$res = sqlite_query($db, "SELECT * FROM 'meshnodes';");
		while ($row = sqlite_fetch_array($res)) {
			$meshnodes[] = array(
				"name" => $row['mn_id'],
				"x" => $row['x'],
				"y" => $row['y'],
				"z" => $row['z']
			);
		}
		return $meshnodes;
	}

	public function updatePositions($submits) {
		
		$excludedSubmits = array("update");

		foreach($submits as $name => $value) {
			if(!in_array($name, $excludedSubmits)) {
				$pattern = '/^[0-9\.]*$/';
				if(preg_match($pattern, $value) == 0) {
					//only numbers allowed
					return false;
				}
				$meshnodename = substr($name, 0, strrpos($name, "_"));
				$varname = substr($name, -1);
				if(!$this->updateMeshnodeInDb($meshnodename, $varname, $value)) {
					return false;
				}
			}
		}
		return true;
	}
	
	private function updateMeshnodeInDb($meshnode = "", $varname, $value) {
		if($meshnode == "") {
			return false;
		}
		$db = Db::getInstance()->getWsnDb();
		if (!$db) die ("DB konnte nicht geöffnet werden.");
		$query = "UPDATE meshnodes SET $varname = '$value' WHERE mn_id = '$meshnode'";
		$res = sqlite_query($db, $query);
		return true;
	}
}

?>
