<?php
/****************************
* Sensornode Class (used for network graph and tree)
*****************************/
	class Sensornode {
		public $name;
		public $neighbours = array();
		public $sensors = array();
		public $gw = "";
		public $datfile = "../sensor/plot.dat";
		public $plotscript = "../sensor/plot.p";
		public $plotimage = "../sensor/plot.png";


			

		public function __construct($name) {
			if($name == "") {
				throw new Exception('Sensornodename needed');
			}
			$this->name = $name;
		}

		public function plot($mn = "") {
			$values = $this->getMeasuredValues(100, $mn);
			if(count($values) == 0) {
				return false;
			} else {
				$this->writeDatFile($values);
				$this->executeGnuPlot();
				return true;
			}
		}

		public function getInformations($mn = "") {
			$informations = array();

			$db = Db::getInstance()->getWsnDb($mn);
			if (!$db) die ("DB konnte nicht geöffnet werden.");

			$query = "SELECT sn_id, value, description FROM sensornodes, properties WHERE sn_id = '".$this->name."' AND sensornodes.prop_id = properties.prop_id;";
			$res = sqlite_query($db, $query);
			while ($row = sqlite_fetch_array($res)) {
				$informations[] = array(
					$row['description'] => $row['value']
				);
			}
			return $informations;
		}

		public function getInformation($prop_id, $mn = "") {
			$db = Db::getInstance()->getWsnDb($mn);
			if (!$db) die ("DB konnte nicht geöffnet werden.");

			$query = "SELECT sn_id, value FROM sensornodes WHERE sn_id = '".$this->name."' AND prop_id = '".$prop_id."';";
			$res = sqlite_query($db, $query);
			while ($row = sqlite_fetch_array($res)) {
				return $row['value'];
			}
		}

		public function updateNeighbours($mn = "") {
			
			$db = Db::getInstance()->getWsnDb($mn);
			if (!$db) die ("DB konnte nicht geöffnet werden.");
			$query = "SELECT * FROM sensornode_network WHERE sn_id = '".$this->name."';";
			$res = sqlite_query($db, $query);
			while ($row = sqlite_fetch_array($res)) {
				$this->neighbours[] = new Sensornode($row['sn_neighbor_id']);
			}
		}
		
		public function getNeighbours($mn = "") {
			$this->neighbours = array();
			$this->updateNeighbours($mn);
			echo"<pre>";
//			print_r($this->neighbours);
			echo"</pre>";
			
			return $this->neighbours;
		}

		public function getSensors($mn = "") {
			$db = Db::getInstance()->getWsnDb($mn);
			if (!$db) die ("DB konnte nicht geöffnet werden.");
			$query = "SELECT * FROM sensors WHERE sn_id = '".$this->name."';";
			$res = sqlite_query($db, $query);
			while ($row = sqlite_fetch_array($res)) {
				if($row['prop_id']/5 == floor($row['prop_id']/5)) {
					$this->sensors[] = new Sensor($row['sn_id'],$row['prop_id']);
				}
			}
			return $this->sensors;
		}

		public function getMeasuredValues($sensor_id, $mn = "") {
			$values = array();
			$db = Db::getInstance()->getWsnDb($mn);
			if (!$db) die ("DB konnte nicht geöffnet werden.");
			$query = "SELECT value, time FROM sensors WHERE sn_id = '".$this->name."' AND prop_id = '".($sensor_id+2)."' ORDER BY time DESC LIMIT 1000;";
			//echo $query;
			$res = sqlite_query($db, $query);
			while ($row = sqlite_fetch_array($res)) {
				$time = $row['time'];
				$value = $row['value'];
				$values[$time] = $value;
			}
			return $values;
		}
		public function writeDatFile($values) {
			$string = "#Date\tValue\n";
			foreach($values as $time => $value) {
				$string .= $time . "\t" . $value . "\n";
			}
			file_put_contents($this->datfile, $string);
		}

		public function executeGnuplot() {
			exec("gnuplot ".$this->plotscript);
		}
	}
?>