<?php

/****************************
* Updating Sensornodes with new program versions
*****************************/

class Updater {

	private $sensors = array();
	private $sensortypes = array();
	private $meshnodegateways = array();
	private $marwisbinary = "/sbin/marwis";
	
	public function __construct() {

	}

	public function processSelectedSensornodes() {
		$sensors = $_GET['sensors'];
		$gws = $_GET['gws'];
		if($sensors == "" && $gws == "") {
			$sensors = array();
			$gws = array();
			$sensors = $_POST['sensornodes'];
			$gws = $_POST['gws'];
		} else {
			$sensors = explode(",", $sensors);
			$gws = explode(",", $gws);
		}
		for($i = 0; $i<count($sensors); $i++) {
			$tmpSensor = new Sensornode($sensors[$i]);
			$tmpSensor->gw = $gws[$i];
			$this->sensors[] = $tmpSensor;
		}
		$this->generateMeshnodegatewaysArray();
	}

	public function showSelectedSensornodes() {
		echo "<h2>Selected Sensornodes</h2>";
		echo "<table class='tableupdate'>";
			echo "<tr>
				<th>Name</th>
				<th>Type</th>
				<th>Gateway Meshnode</th>
			</tr>";				
			foreach($this->sensors as $sensor) {
				$type = $sensor->getInformation(1, $sensor->gw);
				//get meshnodegateway of a sensor
				$meshnodegateway = $sensor->gw;
				echo "<tr>
					<td>$sensor->name</td>
					<td>$type</td>
					<td>$meshnodegateway</td>
				</tr>";
				if(!in_array($type, $this->sensortypes)) {
					$this->sensortypes[] = $type;
				}
			}
		echo "</table><br>";
	}

	public function showImageSelection() {
		echo "<h2>Updating selected Sensornodes</h2>";
	?>		
		<form action="updateSensornodes.php" method="post" enctype="multipart/form-data">
			<?php
			foreach($this->sensors as $sensor) {
				echo "<input type='hidden' name='sensornodes[]' value='".$sensor->name."'>";
				echo "<input type='hidden' name='gws[]' value='".$sensor->gw."'>";
			}
			?>
			<table class="tableupdate">
				<tr>
					<td class="columnlabel"><label for="file">New Image:</label></td>
					<td><?php echo $this->createImageList(); ?> <a href="upload.php">Upload new Image</a></td>
				</tr>
				<tr>
					<td class="columnlabel"></td>
					<td><br><input name="update" type="submit" value="Update" class="button"></td>
				</tr>
			</table>
		</form>
	<?php
	}

	public function updateSensornodes() {
		if(isset($_POST['sensornodes']) && isset($_POST['gws']) && isset($_POST['pv_id'])) {
			$pv_id = $_POST['pv_id'];
			foreach ($this->meshnodegateways as $meshnodegateway => $sensorarray) {

				$codepropcommand = "$this->marwisbinary $meshnodegateway 20 \"$pv_id;" . count($sensorarray);
				foreach($sensorarray as $sensor) {
					$codepropcommand .= ";" . $sensor;
					$this->updateSWComponents($sensor, $pv_id);
				}
				$codepropcommand .= "\"";
				//echo "codepropcommand: $codepropcommand<br>";
				echo "Updating sensors " . implode(",", $sensorarray) . " on meshnode $meshnodegateway, please wait...<br>";
				flush();
				$output = system($codepropcommand, $result);
				ob_flush();
				//exec($codepropcommand, $output, $result);
// 				switch ($result) {
// 				case -1:
// 					echo "Transmission failed<br>";
// 					break;
// 				case 0:
// 					echo "Update successful";
// 					break;
// 				case 1:
// 					echo "Transmission successful, Applicationstart failed";
// 					break;
// 				}
				//echo "$result<br>";
				//echo "$output<br>";
				echo "<br><br>";
				flush();
				ob_flush();
			}
		}
	}

	private function createImageList() {
		$db = Db::getInstance()->getPvDb();
		if (!$db) die ("DB konnte nicht geöffnet werden.");
		$query = "SELECT DISTINCT programs.pv_id, programs.name, programs.version FROM programs WHERE pv_id IN (";		
		$sensortypes = $this->sensortypes;
		for($i = 0; $i < count($sensortypes); $i++) {
			$query .= "SELECT pv_id FROM programs_platforms WHERE pf_id = '".$sensortypes[$i]."'";
			if($i < count($sensortypes)-1) {
				$query .= " INTERSECT ";
			}
		}
		$query .= ") ORDER BY programs.name, programs.version;";
		$res = sqlite_query($db, $query);
		$optioncounter = 0;
		$string = "<select name='pv_id'>";
		while ($row = sqlite_fetch_array($res)) {
			$name = $row['programs.name'];
			$version = $row['programs.version'];
			$pv_id = $row['programs.pv_id'];
			$string .= "<option value='".$pv_id."'>$name - $version</option>";
			$optioncounter++;
		}
		$string .= "</select>";
		if($optioncounter == 0) {
			$string = "(no appropriate image available)";
		}
		return $string;

	}
	
	private function generateMeshnodegatewaysArray() {
		foreach($this->sensors as $sensor) {
			$meshnodegateway = $sensor->gw;
			if(array_key_exists($meshnodegateway, $this->meshnodegateways)) {
				$this->meshnodegateways[$meshnodegateway][] = $sensor->name;
			} else {
				$this->meshnodegateways[$meshnodegateway] = array();
				$this->meshnodegateways[$meshnodegateway][] = $sensor->name;
			}
		}
	}

	private function updateSWComponents($sn_id, $pv_id, $status = 2) {
		$image = new Pv($pv_id);
		
		$db = Db::getInstance()->getWsnDb();
		if (!$db) die ("DB konnte nicht geöffnet werden.");
		$query = "DELETE FROM swcomponents WHERE sn_id = '".$sn_id."' AND program_name = '".$image->name."';"; 
		$res = sqlite_exec($db, $query);
		//status: 0=inactive, 1=active, 2=update transmitted but not yet confirmed
		$query = "INSERT INTO swcomponents (sn_id, pv_id, program_name, updated, status) VALUES ('".$sn_id."', '".$pv_id."', '".$image->name."', '".time()."', '".$status."');";
		$res = sqlite_exec($db, $query);
	}

	public function showErrorNoSensors() {
		echo "<p>Error: no Sensornodes selected. Go back to the <a href='index.php'>Network view</a></p>";
		return;
	}
}

?>