<?php

/*******************
 * config values
 ******************/

$networkdir="/srv/www/tmpconf.d/";
$configdir="/mnt/media/srmconfigs/";
#$node_web_passwd=trim(shell_exec("sudo /sbin/webpass"));
$actualconfig=getActualConfigName($networkdir);

/*******************
 * config functions
 ******************/

// returns current valid configuration name
function getActualConfigName() {
	global $config;
	$configdir = $config['folderTmpNodeConfiguration'];
	$actualconfigname = "";
	if(is_dir($configdir)) {
		$files = scandir($configdir);
		foreach($files as $file) {
			$path_parts = pathinfo($file);
			if($path_parts['basename'] != "." && $path_parts['basename'] != ".." && substr($path_parts['basename'], 0, 1) != "." && is_dir($configdir . $path_parts['basename'])) {
				$actualconfigname = $path_parts['basename'];
			}
		}
	}
	return $actualconfigname;
}

function getAcutualConfigFile($nodename) {
	global $config;
	$configdir = $config['folderTmpNodeConfiguration'];
	$configname = getActualConfigName();
	$configfile = $configdir . $configname . '/' . $nodename . ".conf";

	return $configfile;
}

function getHostname() {
	$hostname = file_get_contents("/etc/conf.d/hostname");
	return $hostname;
}

// returns if a configration already exists
function configExists($configname)
{
   global $configdir;
   $result=false;
   $allconfigs=getSavedConfigNames();
   for ($i=0; $i<count($allconfigs); $i++)
   {
       if ($configname === $allconfigs[$i])
       {
           $result=true;
       }
   }
   return $result;
}

// returns an array with all saved configuration names
function getSavedConfigNames() {
	global $config;
	$configdir = $config['folderUSBNodeConfiguration'];
	$allfiles=scandir($configdir);
	$j=0;
	$result=array();
	for ($i=0; $i<count($allfiles); $i++)
	{
		if (is_dir($configdir."/".$allfiles[$i]) == true && $allfiles[$i] != '.' && $allfiles[$i] != '..')
		{
		$result[$j]=$allfiles[$i];
		$j++;
		}
	}
	return $result;
}

/*******************
 * save functions
 *******************/

// makes a saveable array from the posted values
function getHostArray($post_array)
{
    $nodearr=array();
    $nodearr['AVAIL_DEVICES']=$post_array['AVAIL_DEVICES'];
    $ifs=explode(" ",$post_array['AVAIL_DEVICES']);
    $nodearr['GLOBAL_DEVICES']="";
    for ($i=0; $i<count($ifs); $i++)
    {
        if ($post_array['enable_'.$ifs[$i]] != "disabled" )
        {
           if (strlen($nodearr['GLOBAL_DEVICES']) != 0)
           {
               $nodearr['GLOBAL_DEVICES'].=" ".$ifs[$i];
           }
           else
           {
               $nodearr['GLOBAL_DEVICES'].=$ifs[$i];
           }
        }
    }
    $nodearr['GLOBAL_WIFI_DEVICES']=$post_array['GLOBAL_WIFI_DEVICES'];
    $nodearr['GLOBAL_LIVECD']=$post_array['GLOBAL_LIVECD'];
    $nodearr['GLOBAL_GW']=$post_array['GLOBAL_GW'];
    $nodearr['GLOBAL_GW_IF']=$post_array['GLOBAL_GW_IF'];
//    $nodearr['GLOBAL_NTP']=$post_array['GLOBAL_NTP'];
    if ( isset($post_array['GLOBAL_NTP_POOL']))
    {
        $nodearr['GLOBAL_NTP_POOL']="yes";
    }
    else
    {
        $nodearr['GLOBAL_NTP_POOL']="no";
    }
    $nodearr['GLOBAL_DNS0']=$post_array['GLOBAL_DNS0'];
    $nodearr['GLOBAL_DNS1']=$post_array['GLOBAL_DNS1'];
    for ($i=0; $i<count($ifs); $i++)
    {
        if (stristr($nodearr['GLOBAL_DEVICES'],$ifs[$i]))
        {
            if ($post_array['enable_'.$ifs[$i]] === "dhcp" )
            {
                $nodearr[$ifs[$i].'_DHCP']="yes";
                if (isset($post_array['GLOBAL_OVERRIDE_ROUTE']) && $ifs[$i] === $post_array['OVERRIDE_ROUTE'])
                {
                   $nodearr[$ifs[$i].'_OVERRIDE_ROUTE']="yes";
                }
                else
                {
                   $nodearr[$ifs[$i].'_OVERRIDE_ROUTE']="no";
                }
                if (isset($post_array['GLOBAL_OVERRIDE_DNS']) && $ifs[$i] === $post_array['OVERRIDE_DNS'])
                {
                   $nodearr[$ifs[$i].'_OVERRIDE_DNS']="yes";
                }
                else
                {
                   $nodearr[$ifs[$i].'_OVERRIDE_DNS']="no";
                }
                if (isset($post_array['GLOBAL_OVERRIDE_NTP']) && $ifs[$i] === $post_array['OVERRIDE_NTP'])
                {
                   $nodearr[$ifs[$i].'_OVERRIDE_NTP']="yes";
                }
                else
                {
                   $nodearr[$ifs[$i].'_OVERRIDE_NTP']="no";
                }
                $nodearr[$ifs[$i].'_IP']="";
                $nodearr[$ifs[$i].'_MASK']="";
                $nodearr[$ifs[$i].'_BROADCAST']="";
            }
            else
            {
                $nodearr[$ifs[$i].'_DHCP']="no";
                $nodearr[$ifs[$i].'_OVERRIDE_ROUTE']="no";
                $nodearr[$ifs[$i].'_OVERRIDE_DNS']="no";
                $nodearr[$ifs[$i].'_OVERRIDE_NTP']="no";
                $nodearr[$ifs[$i].'_IP']=$post_array[$ifs[$i].'_IP'];
                $nodearr[$ifs[$i].'_MASK']=$post_array[$ifs[$i].'_MASK'];
                $nodearr[$ifs[$i].'_BROADCAST']="";
            }
            if (stristr($nodearr['GLOBAL_WIFI_DEVICES'],$ifs[$i]))
            {
                $nodearr[$ifs[$i].'_WIFI_STANDARD']=$post_array[$ifs[$i].'_WIFI_STANDARD'];
                $nodearr[$ifs[$i].'_MODE']=$post_array[$ifs[$i].'_MODE'];
                $nodearr[$ifs[$i].'_ENCRYPT']=$post_array[$ifs[$i].'_ENCRYPT'];
                $nodearr[$ifs[$i].'_ESSID']=$post_array[$ifs[$i].'_ESSID'];
            }
        }
        else
        {
            $nodearr[$ifs[$i].'_DHCP']="no";
            $nodearr[$ifs[$i].'_OVERRIDE_ROUTE']="no";
            $nodearr[$ifs[$i].'_OVERRIDE_DNS']="no";
            $nodearr[$ifs[$i].'_OVERRIDE_NTP']="no";
            $nodearr[$ifs[$i].'_IP']="";
            $nodearr[$ifs[$i].'_MASK']="";
            $nodearr[$ifs[$i].'_BROADCAST']="";
            if (stristr($nodearr['GLOBAL_WIFI_DEVICES'],$ifs[$i]))
            {
                $nodearr[$ifs[$i].'_WIFI_STANDARD']="auto";
                $nodearr[$ifs[$i].'_MODE']="ad-hoc";
                $nodearr[$ifs[$i].'_ENCRYPT']="";
                $nodearr[$ifs[$i].'_ESSID']="";
            }

        }
    }
    return $nodearr;
}

// saves a temporary nodeconfig
function saveTempFile($nodearr,$networkdir,$node)
{
    $keys=array_keys($nodearr);
    $file=fopen($networkdir."/".$node.".tmp", "w");
    if (!$file)
    {
        return false;
    }
    $keys=array_keys($nodearr);
    for ($i=0;$i<count($keys);$i++)
    {
        $string=$keys[$i].'="'.$nodearr[$keys[$i]].'"';
        $string=$string."\n";
        fwrite ($file, $string);
    }
    fclose ($file);
    return true;
}

// moves the previously saved tempfile
function moveTempFile($networkdir,$node)
{
    $retval=shell_exec("mv ".$networkdir."/".$node.".tmp ".$networkdir."/".$node.".conf");
    if (isset($retval))
    {
        return true;
    }
    else
    {
        return false;
    }
}


/*******************
 * net functions
 *******************/

// returns true if a locally resolved host can be pinged
function ping_local($hostname)
{
   $answer=false;
   $local=shell_exec('grep '.$hostname.' /etc/hosts');
   if (isset($local))
   {
      $alive=shell_exec('sudo /bin/ping -c 1 '.$hostname);
      if (isset($alive))
      {
          $answer=true;
      }
   }
   return $answer;
}

// calculates the network of a given ip with mask
function getCidrNet($ip,$mask)
{
    $bin_mask = '';
    for($i=1;$i<=32;$i++)
    {
       $bin_mask .= $mask >= $i ? '1' : '0';
    }
    $bin_ip=decbin(ip2long($ip));
    $addzeros=32-strlen($bin_ip);
    for ( $i=0;$i<$addzeros;$i++ )
    {
       $bin_ip="0".$bin_ip;
    }
    $bin_net=$bin_ip & $bin_mask;
    $net='';
    for ($i=0;$i<4;$i++)
    {
        $bin_part=substr($bin_net,$i*8,8);
        $net.=bindec($bin_part).".";
    }
    $net=substr($net,0,strlen($net)-1);
    return $net."/".$mask;
}

// generates a network array from the big node array
function calcNet($bigarray)
{
    $allhosts=array_keys($bigarray);
    $allnet=array();
    for ($i=0; $i<count($allhosts); $i++)
    {
        $allifs=explode(" ", $bigarray[$allhosts[$i]]['GLOBAL_DEVICES']);
        for ($j=0; $j<count($allifs); $j++)
        {
            $member=array();
            $is_wifi=stristr($bigarray[$allhosts[$i]]['GLOBAL_WIFI_DEVICES'],$allifs[$j]);
            $member['name']=$allhosts[$i];
            $member['iface']=$allifs[$j];
            $member['ip']=$bigarray[$allhosts[$i]][$allifs[$j].'_IP'];
            $member['livecd']=$bigarray[$allhosts[$i]]['GLOBAL_LIVECD'];
            $net=getCidrNet($member['ip'],$bigarray[$allhosts[$i]][$allifs[$j].'_MASK']);
            if ( $bigarray[$allhosts[$i]][$allifs[$j].'_DHCP'] === "yes" || $net === "0.0.0.0/0" || $net === "0.0.0.0/" )
            {
                 $is_wifi=false;
                 $net="Unconfigured interfaces";
            }
            if ($is_wifi)
            {
                 $essid=$bigarray[$allhosts[$i]][$allifs[$j].'_ESSID'];
                 $netid=$net.$essid.$bigarray[$allhosts[$i]][$allifs[$j].'_ENCRYPT'];
            }
            else
            {
                 $netid=$net;
            }
            if (array_key_exists($netid,$allnet) )
            {
                 $members=$allnet[$netid]['members'];
                 $members[count($members)]=$member;
                 $allnet[$netid]['members']=$members;
            }
            else
            {
                 $allnet[$netid]['net']=$net;
                 if ($is_wifi)
                 {
                     $allnet[$netid]['essid']=$essid;
                 }
                 $members=array();
                 $members[0]=$member;
                 $allnet[$netid]['members']=$members;
            }
        }
    }
    return $allnet;
}


/*******************
 * load functions
 *******************/

// returns an array from a node configfile
function explodeConfigArray($configfile)
{
//	echo $configfile;
	$contentarray = array();
	if(file_exists($configfile) && is_readable($configfile)) {
		$tmplines = file($configfile, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
	}
//	echo "<pre>"; print_r($tmplines); echo "</pre>";
	foreach($tmplines as $tmpline) {
		$tmpline = trim($tmpline);
		if(substr($tmpline, 0, 1) == "#") continue;
		$tmparray = explode("=", $tmpline);
		$contentarray[$tmparray[0]] = trim($tmparray[1], "\"");
	}
//	echo "<pre>"; print_r($contentarray); echo "</pre>";
	return $contentarray;
}

// parses a directoy for node configfiles and returns a big array of them
function parseConfig($networkdir)
{
    $bigarray=array();
    $allfiles=scandir($networkdir);
    $j=0;
    for ($i=0; $i<count($allfiles); $i++)
    {
        $path_parts = pathinfo($allfiles[$i]);
        if ($path_parts['extension'] === "conf")
        {
            $path_parts['filename']=substr($path_parts['basename'], 0, -(strlen($path_parts['extension']) + ($path_parts['extension'] == '' ? 0 : 1)));
            $allhosts[$j]=$path_parts['filename'];
            $bigarray[$allhosts[$j]]=explodeConfigArray($networkdir."/".$path_parts['basename']);
            $j++;
        }
    }
    return $bigarray;
}

function readConfiguration($configname) {
	global $config;
	$configdir = $config['folderTmpNodeConfiguration'];
	$configuration = array();
	if(existingPASSWDFile($configdir.$configname)) {
		$configuration['root_pass'] = "**********";
		$configuration['root_pass1'] = "**********";
	} else {
		$configuration['root_pass'] = "";
		$configuration['root_pass1'] = "";
	}
	$configuration['hosts'] = readHostConfigurations($configname);
	foreach($configuration['hosts'] as $firstnode) {
		break;
	}
	$configuration['ipv6_prefix'] = $firstnode['GLOBAL_CFNET_PREFIX'];
	
	return $configuration;
}

function existingPASSWDFile($configpath) {
	return is_file($configpath.'/PASSWD');
}

function readHostConfigurations($configname) {
	global $config;
	$configdir = $config['folderTmpNodeConfiguration'];
	$hosts = array();
	$files = scandir($configdir.$configname);
	foreach($files as $file) {
		$path_parts = pathinfo($file);
		if($path_parts['extension'] == "conf") {
			$hosts[$path_parts['filename']] = explodeConfigArray($configdir.$configname."/".$file);
		}
	}
	return $hosts;
}

function getDomainName($configdir, $configname) {
	$domainname = "";
	$filename = "domainname";
	if(is_file($configdir.$configname.'/'.$filename)) {
		$domainname = file_get_contents($configdir.$configname.'/'.$filename);
	}
	return $domainname;
}

function getWebpass($configdir, $configname) {
	$webpass = "";
	$filename = "webpass";
	if(is_file($configdir.$configname.'/'.$filename)) {
		$webpass = file_get_contents($configdir.$configname.'/'.$filename);
	}
	return $webpass;
}
function getJoinNetwork($configdir, $configname) {
	$joinNet = "";
	$filename = "joinnet";
	if(is_file($configdir.$configname.'/'.$filename)) {
		$join = preg_split("/[\/:]+/", file_get_contents($configdir.$configname.'/'.$filename));
		$joinNet = $join[0];
	}
	return $joinNet;
}
function getJoinMask($configdir, $configname) {
	$joinMask = "";
	$filename = "joinnet";
	if(is_file($configdir.$configname.'/'.$filename)) {
		$join = preg_split("/[\/:]+/", file_get_contents($configdir.$configname.'/'.$filename));
		$joinMask = $join[1];
	}
	return $joinMask;
}
function getJoinEssid($configdir, $configname) {
	$joinEssid = "";
	$filename = "joinnet";
	if(is_file($configdir.$configname.'/'.$filename)) {
		$join = preg_split("/[\/:]+/", file_get_contents($configdir.$configname.'/'.$filename));
		$joinEssid = $join[2];
	}
	return $joinEssid;
}

function getConfiguredNodes($configname) {
	global $configdir;
	$configuredNodes = array();
	if(!configExists($configname)) {
		return;
	} else {
		$files = scandir($configdir.$configname);
		foreach($files as $file) {
			if(is_dir($configdir.$configname.'/'.$file) && $file != "." && $file != "..") {
				$configuredNodes[$file] = array();
			}
		}
	}
	return $configuredNodes;
}
function showMessage($messagetype, $message) {
	if($messagetype == "" && $message == "") {
		return;
	}
	if($messagetype == "success") {
		echo "<div class='success_message'>";
			echo "<table><tr><td valign='top'>Success: </td><td valign='top'>$message</td></tr></table>";
		echo "</div>";
	} elseif($messagetype == "error") {
		echo "<div class='error_message'>";
			echo "<table><tr><td valign='top'>Error: </td><td valign='top'>$message</td></tr></table>";
		echo "</div>";
	} elseif($messagetype == "info") {
		echo "<div class='info_message'>";
			echo "<table><tr><td valign='top'>Info: </td><td valign='top'>$message</td></tr></table>";
		echo "</div>";
	}
	$messagetype = "";
	$message = "";
}

function getDeployedNodes() {
	global $config;
	$nodes = array();
	if(is_dir($config['folderDeployedNodeConfiguration'])) {
		$files = scandir($config['folderDeployedNodeConfiguration']);
		foreach($files as $file) {
			$path_parts = pathinfo($file);
			if($path_parts['basename'] != "." && $path_parts['basename'] != ".." && $path_parts['extension'] == "conf") {
				$nodes[] = $file;
			}
		}
	}
	return $nodes;
}

function loadConfigsFromNetwork($newConfigName) {
	global $config;
	$domain = trim(file_get_contents("/etc/conf.d/domainname"));
	discardActualConfig();
	generateActualConfig($newConfigName);
	$deployedNodes = getDeployedNodes();
	foreach($deployedNodes as $deployedNode) {
		//copy conf
		copy($config['folderDeployedNodeConfiguration'] . $deployedNode, $config['folderTmpNodeConfiguration'] . $newConfigName . "/" . $deployedNode);
		//copy pubkey
		$oldppname = "root-" . str_replace(".conf", "", $deployedNode) . ".$domain.pub";
		$newppname = str_replace(".$domain", "", $oldppname);
		$chmodcommand1 = "sudo /bin/chmod 755 " . $config['folderCurrentPubKey'];
        	$chmodcommand2 = "sudo /bin/chmod 700 " . $config['folderCurrentPubKey'];
		shell_exec($chmodcommand1);
        	copy($config['folderCurrentPubKey'] . $oldppname, $config['folderTmpNodeConfiguration'] . $newConfigName . '/' . $newppname);
		shell_exec($chmodcommand2);
	}
}

function loadConfigsFromUSB($configname) {
	global $config;
	$configdir = $config['folderTmpNodeConfiguration'];
	$usbdir = $config['folderUSBNodeConfiguration'];
	discardActualConfig();
	generateActualConfig($configname);
	$files = scandir($usbdir . $configname);
	foreach($files as $file) {
		if(is_file($usbdir . $configname . "/" . $file)) {
			copy($usbdir . $configname . "/" . $file, $configdir . $configname . "/" . $file);
		}
	}
}

function saveConfigToUSB() {
	global $config;
	$actualConfigName = getActualConfigName();
	$configdir = $config['folderTmpNodeConfiguration'];
	$usbdir = $config['folderUSBNodeConfiguration'];
	if(!is_dir($usbdir . $actualConfigName)) {
		mkdir($usbdir . $actualConfigName);
		$files = scandir($configdir . $actualConfigName);
		foreach($files as $file) {
			if(is_file($configdir . $actualConfigName . "/" . $file)) {
				copy($configdir . $actualConfigName . "/" . $file, $usbdir . $actualConfigName . "/" . $file);
			}
		}
	} else {
		removeDir($usbdir . $actualConfigName);
		saveConfigToUSB();
	}
}
function createNewConfig($configname) {
	discardActualConfig();
	generateActualConfig($configname);
}

function discardActualConfig() {
	global $config;
	$actualConfigName = getActualConfigName();
	if($actualConfigName != "") {
		removeDir($config['folderTmpNodeConfiguration'] . $actualConfigName . "/");
	}
}

function removeDir($dir) {
	if (is_dir($dir)) {
		foreach (new DirectoryIterator($dir) as $file) {
			if ($file->isFile()) {
				unlink($file->getPathName());
			}
		}
		rmdir($dir);
	}
}

function generateActualConfig($newConfigName) {
	global $config;
	if(getActualConfigName() == "") {
		mkdir($config['folderTmpNodeConfiguration'] . $newConfigName);
	} else {
		loadConfigsFromNetwork($newConfigName);
	}
}
//TODO
function generateIPv6Prefix() {
	$ipv6_prefix = "fd49:3799:623e";
	return $ipv6_prefix;

}

function checkImageNamingConvention($filename) {
	$pattern = '/^(alix|alixmgmt|wrap|meraki|xen)-image-(.+)\.bin\.gz$/i';
	if(preg_match($pattern, $filename, $filenamePattern) > 0) {
		return $filenamePattern;
	} else {
		return false;
	}
}
function checkCommandNamingConvention($filename) {
	$pattern = '/^(.+)\.cmd$/i';
	if(preg_match($pattern, $filename, $filenamePattern) > 0) {
		return $filenamePattern;
	} else {
		return false;
	}
}

function generateNrDropdown($start, $end, $name, $selected="", $emptyEntry = false) {
	$string = "";
	$string .= "<select name='".$name."' class='shortdropdown' >\n";
	if($emptyEntry) {
		$string .= "<option value=''";
			if($selected == "") {
				$string .= " selected='selected'";
			}
		$string .= "></option>\n";
	}
	for ($i=$start;$i<=$end;$i++) {
		if ($i == $selected && $selected != "") {
			$string .= "<option value='$i' selected='selected'>$i</option>\n";
		} else {
			$string .= "<option value='$i'>$i</option>\n";
		}
	}
	$string .= "</select>\n";
	return $string;
}

function generateWlanStandardDropdown($name, $selected="") {
	$string = "";
	if($selected == "") $selected = "g";
	$standards = array('auto', 'a', 'b', 'g', 'h', 'n');
	$string .= "<select name='".$name."' class='shortdropdown'>\n";
	foreach($standards as $standard) {
		if($selected == $standard) {
			$string .= "<option value='$standard' selected='selected'>$standard</option>\n";
		} else {
			$string .= "<option value='$standard'>$standard</option>\n";
		}
	}
	$string .= "</select>\n";
	return $string;

}

function generateCountryCodeDropdown($name, $selected="") {
	$string = "";
	if($selected == "") $selected = "756";
	$codes = array(
"Aaland Islands" => "248",
"Afghanistan" => "004",
"Albania" => "008",
"Algeria" => "012",
"American Samoa" => "016",
"Andorra" => "020",
"Angola" => "024",
"Anguilla" => "660",
"Antarctica" => "010",
"Antigua And Barbuda" => "028",
"Argentina" => "032",
"Armenia" => "051",
"Aruba" => "533",
"Australia" => "036",
"Austria" => "040",
"Azerbaijan" => "031",
"Bahamas" => "044",
"Bahrain" => "048",
"Bangladesh" => "050",
"Barbados" => "052",
"Belarus" => "112",
"Belgium" => "056",
"Belize" => "084",
"Benin" => "204",
"Bermuda" => "060",
"Bhutan" => "064",
"Bolivia" => "068",
"Bosnia And Herzegowina" => "070",
"Botswana" => "072",
"Bouvet Island" => "074",
"Brazil" => "076",
"British Indian Ocean Territory" => "086",
"Brunei Darussalam" => "096",
"Bulgaria" => "100",
"Burkina Faso" => "854",
"Burundi" => "108",
"Cambodia" => "116",
"Cameroon" => "120",
"Canada" => "124",
"Cape Verde" => "132",
"Cayman Islands" => "136",
"Central African Republic" => "140",
"Chad" => "148",
"Chile" => "152",
"China" => "156",
"Christmas Island" => "162",
"Cocos (Keeling) Islands" => "166",
"Colombia" => "170",
"Comoros" => "174",
"Congo, Democratic Republic Of (Was Zaire)" => "180",
"Congo, Republic Of" => "178",
"Cook Islands" => "184",
"Costa Rica" => "188",
"Cote D'Ivoire" => "384",
"Croatia (Local Name: Hrvatska)" => "191",
"Cuba" => "192",
"Cyprus" => "196",
"Czech Republic" => "203",
"Denmark" => "208",
"Djibouti" => "262",
"Dominica" => "212",
"Dominican Republic" => "214",
"Ecuador" => "218",
"Egypt" => "818",
"El Salvador" => "222",
"Equatorial Guinea" => "226",
"Eritrea" => "232",
"Estonia" => "233",
"Ethiopia" => "231",
"Falkland Islands (Malvinas)" => "238",
"Faroe Islands" => "234",
"Fiji" => "242",
"Finland" => "246",
"France" => "250",
"French Guiana" => "254",
"French Polynesia" => "258",
"French Southern Territories" => "260",
"Gabon" => "266",
"Gambia" => "270",
"Georgia" => "268",
"Germany" => "276",
"Ghana" => "288",
"Gibraltar" => "292",
"Greece" => "300",
"Greenland" => "304",
"Grenada" => "308",
"Guadeloupe" => "312",
"Guam" => "316",
"Guatemala" => "320",
"Guinea" => "324",
"Guinea-Bissau" => "624",
"Guyana" => "328",
"Haiti" => "332",
"Heard And Mc Donald Islands" => "334",
"Honduras" => "340",
"Hong Kong" => "344",
"Hungary" => "348",
"Iceland" => "352",
"India" => "356",
"Indonesia" => "360",
"Iran (Islamic Republic Of)" => "364",
"Iraq" => "368",
"Ireland" => "372",
"Israel" => "376",
"Italy" => "380",
"Jamaica" => "388",
"Japan" => "392",
"Jordan" => "400",
"Kazakhstan" => "398",
"Kenya" => "404",
"Kiribati" => "296",
"Korea, Democratic People'S Republic Of" => "408",
"Korea, Republic Of" => "410",
"Kuwait" => "414",
"Kyrgyzstan" => "417",
"Lao People'S Democratic Republic" => "418",
"Latvia" => "428",
"Lebanon" => "422",
"Lesotho" => "426",
"Liberia" => "430",
"Libyan Arab Jamahiriya" => "434",
"Liechtenstein" => "438",
"Lithuania" => "440",
"Luxembourg" => "442",
"Macau" => "446",
"Macedonia, The Former Yugoslav Republic Of" => "807",
"Madagascar" => "450",
"Malawi" => "454",
"Malaysia" => "458",
"Maldives" => "462",
"Mali" => "466",
"Malta" => "470",
"Marshall Islands" => "584",
"Martinique" => "474",
"Mauritania" => "478",
"Mauritius" => "480",
"Mayotte" => "175",
"Mexico" => "484",
"Micronesia, Federated States Of" => "583",
"Moldova, Republic Of" => "498",
"Monaco" => "492",
"Mongolia" => "496",
"Montserrat" => "500",
"Morocco" => "504",
"Mozambique" => "508",
"Myanmar" => "104",
"Namibia" => "516",
"Nauru" => "520",
"Nepal" => "524",
"Netherlands" => "528",
"Netherlands Antilles" => "530",
"New Caledonia" => "540",
"New Zealand" => "554",
"Nicaragua" => "558",
"Niger" => "562",
"Nigeria" => "566",
"Niue" => "570",
"Norfolk Island" => "574",
"Northern Mariana Islands" => "580",
"Norway" => "578",
"Oman" => "512",
"Pakistan" => "586",
"Palau" => "585",
"Palestinian Territory, Occupied" => "275",
"Panama" => "591",
"Papua New Guinea" => "598",
"Paraguay" => "600",
"Peru" => "604",
"Philippines" => "608",
"Pitcairn" => "612",
"Poland" => "616",
"Portugal" => "620",
"Puerto Rico" => "630",
"Qatar" => "634",
"Reunion" => "638",
"Romania" => "642",
"Russian Federation" => "643",
"Rwanda" => "646",
"Saint Helena" => "654",
"Saint Kitts And Nevis" => "659",
"Saint Lucia" => "662",
"Saint Pierre And Miquelon" => "666",
"Saint Vincent And The Grenadines" => "670",
"Samoa" => "882",
"San Marino" => "674",
"Sao Tome And Principe" => "678",
"Saudi Arabia" => "682",
"Senegal" => "686",
"Serbia And Montenegro" => "891",
"Seychelles" => "690",
"Sierra Leone" => "694",
"Singapore" => "702",
"Slovakia" => "703",
"Slovenia" => "705",
"Solomon Islands" => "090",
"Somalia" => "706",
"South Africa" => "710",
"South Georgia And The South Sandwich Islands" => "239",
"Spain" => "724",
"Sri Lanka" => "144",
"Sudan" => "736",
"Suriname" => "740",
"Svalbard And Jan Mayen Islands" => "744",
"Swaziland" => "748",
"Sweden" => "752",
"Switzerland" => "756",
"Syrian Arab Republic" => "760",
"Taiwan" => "158",
"Tajikistan" => "762",
"Tanzania, United Republic Of" => "834",
"Thailand" => "764",
"Timor-Leste" => "626",
"Togo" => "768",
"Tokelau" => "772",
"Tonga" => "776",
"Trinidad And Tobago" => "780",
"Tunisia" => "788",
"Turkey" => "792",
"Turkmenistan" => "795",
"Turks And Caicos Islands" => "796",
"Tuvalu" => "798",
"Uganda" => "800",
"Ukraine" => "804",
"United Arab Emirates" => "784",
"United Kingdom" => "826",
"United States" => "840",
"United States Minor Outlying Islands" => "581",
"Uruguay" => "858",
"Uzbekistan" => "860",
"Vanuatu" => "548",
"Vatican City State (Holy See)" => "336",
"Venezuela" => "862",
"Viet Nam" => "704",
"Virgin Islands (British)" => "092",
"Virgin Islands (U.S.)" => "850",
"Wallis And Futuna Islands" => "876",
"Western Sahara" => "732",
"Yemen" => "887",
"Zambia" => "894",
"Zimbabwe" => "716",
);
	ksort($codes);
	$string .= "<select name='".$name."'>\n";
	foreach($codes as $country => $value) {
		if($selected == $value) {
			$string .= "<option value='$value' selected='selected'>$country ($value)</option>\n";
		} else {
			$string .= "<option value='$value'>$country ($value)</option>\n";
		}
	}
	$string .= "</select>\n";
	return $string;

}



function fillConfigArrayWithPosts($nodeconfiguration) {
	$global_devices = getGlobalDevices($nodeconfiguration);
	$avail_devices = getAvailableDevices($nodeconfiguration);
	$global_wifi_devices = getGlobalWifiDevices($nodeconfiguration);
	$booleanGlobalFields = array(
				'GLOBAL_MGMT',
//				'GLOBAL_CFNET6',
				'GLOBAL_NTP_BE_SERVER',
				'GLOBAL_NTP_BE_CLIENT',
				'GLOBAL_NTP_POOL',
				'GLOBAL_RADVD_START',
				'GLOBAL_UDHCPD_START',
				'GLOBAL_UDHCPD_STATIC_ONLY',
				'NETFILTER_START',
				'NETFILTER6_START',
				'NETFILTER_LOG',
				'NETFILTER_ALLOW_LOCAL_OUT',
				'NETFILTER_ALLOW_FORWARD',
				'NETFILTER6_ALLOW_LOCAL_OUT',
				'NETFILTER6_ALLOW_FORWARD',
				);
	$booleanIfFields = array(
				'_DHCP',
				'_OVERRIDE_ROUTE',
				'_OVERRIDE_DNS',
				'_OVERRIDE_NTP',
				'_OUTDOOR',
				);
		

	foreach($nodeconfiguration as $key => $value) {
		if(isset($_POST[$key]) && $value != $_POST[$key]) {
			$nodeconfiguration[$key] = $_POST[$key];
		}
	}
	if(isset($_POST['updatingnode']) && $_POST['updatingnode'] == '1') {
		foreach($booleanGlobalFields as $field) {
			if(isset($_POST[$field])) {
				$nodeconfiguration[$field] = "yes";
				//insert management tag in config file
				if($field == "GLOBAL_MGMT") {
					if(substr($nodeconfiguration['GLOBAL_SYSTYPE'], -4) != "mgmt") {
						
						$nodeconfiguration['GLOBAL_SYSTYPE'] = $nodeconfiguration['GLOBAL_SYSTYPE'] . "mgmt";
					}
				}
			} else {
				$nodeconfiguration[$field] = "no";
			}
			if($nodeconfiguration['GLOBAL_MGMT'] == "no") {
				if(substr($nodeconfiguration['GLOBAL_SYSTYPE'], -4) == "mgmt") {
					$nodeconfiguration['GLOBAL_SYSTYPE'] = substr($nodeconfiguration['GLOBAL_SYSTYPE'], 0, -4);
				}
			}
		}
		$global_devices = array();
		foreach($avail_devices as $avail_device) {
			if(isset($_POST[$avail_device.'_config_mode']) && $_POST[$avail_device.'_config_mode'] != 'disabled') {
				$global_devices[] = $avail_device;
			} else {
				unset($nodeconfiguration[$avail_device . '_DHCP']);
				unset($nodeconfiguration[$avail_device . '_OVERRIDE_ROUTE']);
				unset($nodeconfiguration[$avail_device . '_OVERRIDE_DNS']);
				unset($nodeconfiguration[$avail_device . '_OVERRIDE_NTP']);
				unset($nodeconfiguration[$avail_device . '_IP']);
				unset($nodeconfiguration[$avail_device . '_MASK']);
				unset($nodeconfiguration[$avail_device . '_IP6']);
				unset($nodeconfiguration[$avail_device . '_MASK6']);
				unset($nodeconfiguration[$avail_device . '_STANDARD']);
				unset($nodeconfiguration[$avail_device . '_ESSID']);
			}
		}
		foreach($global_devices as $global_device) {
			foreach($booleanIfFields as $field) {
				if(isset($_POST[$global_device.$field])) {
					$nodeconfiguration[$global_device.$field] = "yes";
				} else {
					$nodeconfiguration[$global_device.$field] = "no";
				}
			}
			if($_POST[$global_device.'_config_mode'] == 'dhcp') {
				$nodeconfiguration[$global_device.'_DHCP'] = "yes";
			} else {
				$nodeconfiguration[$global_device.'_DHCP'] = "no";	
			}
			$nodeconfiguration[$global_device.'_IP'] = $_POST[$global_device.'_IP'];
			$nodeconfiguration[$global_device.'_MASK'] = $_POST[$global_device.'_MASK'];
			$nodeconfiguration[$global_device.'_IP6'] = $_POST[$global_device.'_IP6'];
			$nodeconfiguration[$global_device.'_MASK6'] = $_POST[$global_device.'_MASK6'];
			if(in_array($global_device, $global_wifi_devices)) {
				$nodeconfiguration[$global_device.'_STANDARD'] = $_POST[$global_device.'_STANDARD'];
				$nodeconfiguration[$global_device.'_ESSID'] = $_POST[$global_device.'_ESSID'];
			}
			if(isset($_POST['dns_dhcp'])) {
				$nodeconfiguration[$global_device.'_OVERRIDE_DNS'] = "yes";
			} else {
				$nodeconfiguration[$global_device.'_OVERRIDE_DNS'] = "no";
			}
			if(isset($_POST['ntp_dhcp'])) {
				$nodeconfiguration[$global_device.'_OVERRIDE_NTP'] = "yes";
			} else {
				$nodeconfiguration[$global_device.'_OVERRIDE_NTP'] = "no";
			}
			if(isset($_POST['route_dhcp'])) {
				if($_POST['GLOBAL_GW_IF'] == $global_device) {
					$nodeconfiguration[$_POST['GLOBAL_GW_IF']."_OVERRIDE_ROUTE"] = "yes";
				} else {
					$nodeconfiguration[$global_device."_OVERRIDE_ROUTE"] = "no";
				}
			} else {
				$nodeconfiguration[$global_device."_OVERRIDE_ROUTE"] = "no";
			}
		}

		if(count($_POST['GLOBAL_ADHOCROUTING_DEVICES']) > 0) {
			$nodeconfiguration['GLOBAL_ADHOCROUTING_DEVICES'] = implode(" ", $_POST['GLOBAL_ADHOCROUTING_DEVICES']);
		}
		if(!isset($_POST['GLOBAL_ADHOCROUTING_DEVICES'])) {
			$nodeconfiguration['GLOBAL_ADHOCROUTING_DEVICES'] = "";
		}
	}
	$nodeconfiguration['GLOBAL_DEVICES'] = implode(" ", $global_devices);
	return $nodeconfiguration;
}
function deleteNodeConfFile($nodename) {
	global $config;
	$configdir = $config['folderTmpNodeConfiguration'];
	$configname = getActualConfigName();
	$files = scandir($configdir . $configname);
	foreach($files as $file) {
		$path_parts = pathinfo($configdir.$configname.'/'.$file);
		if(is_file($configdir.$configname.'/'.$file) && $path_parts['basename'] == $nodename.".conf"){
			unlink($configdir.$configname . "/" . $file);
		}
	}
}
function writeNodeConfFile($nodename, $nodeconfiguration) {
	global $config;
	$configdir = $config['folderTmpNodeConfiguration'];
	$configname = getActualConfigName();
	$filename  = $nodename . ".conf";
	$string = getDefaultNodeConfFile($nodeconfiguration);
	foreach($nodeconfiguration as $key => $value) {
		$pattern = "/$key=\"(.*)\"/i";
		$replacement = "$key=\"$value\"";
		$string = preg_replace($pattern, $replacement, $string);
	}
	$success = file_put_contents($configdir . $configname . "/" . $filename , $string);
}

function getDefaultNodeConfFile($nodeconfiguration) {
	global $config;
	$nodetypeconfigdir = $config['folderNodeTypeConfiguration'];
	$string = file_get_contents($nodetypeconfigdir."types/".$nodeconfiguration['GLOBAL_SUBSYSTYPE'].".tmpl");
	$string .= file_get_contents($nodetypeconfigdir."common.tmpl");
	$global_devices = getGlobalDevices($nodeconfiguration);
	foreach($global_devices as $global_device) {
		$string .= file_get_contents($nodetypeconfigdir."devices/".$global_device.".tmpl");
	}
	return $string;
}

function getAvailableNodeTypes() {
	global $config;
	$nodetypeconfigdir = $config['folderNodeTypeConfiguration'] . "types/";
	$nodetypes = array();
	$files = scandir($nodetypeconfigdir);
	foreach($files as $file) {
		$path_parts = pathinfo($nodetypeconfigdir.$file);
		if(is_file($nodetypeconfigdir.$file) && $path_parts['extension'] == "tmpl" && $file != "common.tmpl") {
			$nodetypes[] = $path_parts['filename'];
		}
	}
	return $nodetypes;
}

function getDefaultNodeConfiguration($nodetype) {
	global $config;
	$nodetypeconfigdir = $config['folderNodeTypeConfiguration'];
	$typeconfigs = explodeConfigArray($nodetypeconfigdir."types/".$nodetype.".tmpl");
	$globalconfigs = explodeConfigArray($nodetypeconfigdir."common.tmpl");
	$nodeconfiguration = array_merge($typeconfigs, $globalconfigs);
	$global_devices = getGlobalDevices($nodeconfiguration);
	foreach($global_devices as $global_device) {
		$tmpdeviceconfig = explodeConfigArray($nodetypeconfigdir."devices/".$global_device.".tmpl");
		$nodeconfiguration = array_merge($nodeconfiguration, $tmpdeviceconfig);
	}
	return $nodeconfiguration;
}


function getAvailableDevices($nodeconfiguration) {
	$avail_devices = explode(" ", $nodeconfiguration['AVAIL_DEVICES']);
	if(count($avail_devices) == 1 && $avail_devices[0] == "") $avail_devices = array();
	return $avail_devices;
}

function getGlobalDevices($nodeconfiguration) {
	$global_devices = explode(" ", $nodeconfiguration['GLOBAL_DEVICES']);
	if(count($global_devices) == 1 && $global_devices[0] == "") $global_devices = array();
	return $global_devices;
}

function getGlobalWifiDevices($nodeconfiguration) {
	$global_wifi_devices = explode(" ", $nodeconfiguration['GLOBAL_WIFI_DEVICES']);
	if(count($global_wifi_devices) == 1 && $global_wifi_devices[0] == "") $global_wifi_devices = array();
	return $global_wifi_devices;
}

function nodeConfigExists($nodename) {
	global $config;
	$configdir = $config['folderTmpNodeConfiguration'];
	$configname = getActualConfigName();
	$filename  = $nodename . ".conf";
	if(is_file($configdir.$configname.'/'.$filename)) {
		return true;
	} else {
		return false;
	}
}

function distributeNewImage() {
	global $config;
	$updatefile = $config['imageUpdateFolder'] . "update";
	
	if(!isset($_POST['newImageTxt']) || $_POST['newImageTxt'] == "") {
		return "Choose a file";
	}
	if(($filenamePattern = checkImageNamingConvention($_POST['newImageTxt'])) != false) {
		if(!file_exists($updatefile) || filesize($updatefile) == 0) {
			return storeNewImage($filenamePattern);
		} else {
			return "Imagedistribution in progress\n";
		}
	} else {
		return "Filename does not match the naming convention '&#060;nodetype&#062;-image-&#060;version&#062;.bin.gz'\n";
	}
	return "";
}
function storeNewImage($filenamePattern) {
	global $config;
	
	$path = $config['imageUpdateFolder'];
	
	if(is_writable($path)) {		
		if(is_uploaded_file($_FILES['newImage']['tmp_name'])) {
			$sha1 = sha1_file($_FILES['newImage']['tmp_name']);
			if(move_uploaded_file($_FILES['newImage']['tmp_name'], $path . $_FILES['newImage']['name'])) { 
				$nodetype = $filenamePattern[1];
				$imageversion = $filenamePattern[2];
				return generateUpdateFile($nodetype, $imageversion, $sha1, $_FILES['newImage']['name']);
			} else {
				return "Could not move the new image to $patch";
			}
		}
	} else {
		return "$path is not writable";
	}
}

function generateUpdateFile($nodetype, $imageversion, $sha1, $imagename) {
	global $config;
	$updatefile = $config['imageUpdateFolder'] . "update";
	$imagefile = $config['imageUpdateFolder'] . $imagename;
	file_put_contents($updatefile, "$nodetype $imageversion $sha1\n");
	return "";
}

function stopImageDistribution() {
	global $config;

	$path = $config['imageUpdateFolder'];
	
	if(is_writable($path)) {
		if ($handle = opendir($path)) {
			while (false !== ($file = readdir($handle))) {
				if ($file != "." && $file != "..") {
					if(file_put_contents($path . $file, "") === false) {
						return "$path$file not writable";
					};
				}
			}
			closedir($handle);
		}
	} else {
		return "$path not writable";
	}
}

function uploadCommand() {
	global $config;
	$commandFolder = $config['commandFolder'];
	$dataFolder = $config['commandDataFolder'];

	if(!isset($_POST['newCommandTxt']) || $_POST['newCommandTxt'] == "") {
		return "Choose a command file";
	}
	if(($filenamePattern = checkCommandNamingConvention($_POST['newCommandTxt'])) != false) {
		if(($res = storeCommandFile()) == "") {
			if(isset($_POST['newCommandDataTxt']) && $_POST['newCommandDataTxt'] != "") {
				if(($res = storeCommandDataFile()) != "") {
					return $res;
				}
			}
		} else {
			return $res;
		}
	} else {
		return "Filename '".$_POST['newCommandTxt']."' does not match the naming convention '*.cmd'\n";
	}
	return "";
}

function storeCommandFile() {
	global $config;
	$path = $config['commandFolder'];
	if(is_writable($path)) {
		if(is_uploaded_file($_FILES['newCommand']['tmp_name'])) {
			if(!move_uploaded_file($_FILES['newCommand']['tmp_name'], $path . $_FILES['newCommand']['name'])) { 
				return "Could not store the new command file to $path";
			}
		}
	} else {
		return "$path is not writable";
	}
	return "";
}

function storeCommandDataFile() {
	global $config;
	$path = $config['commandDataFolder'];
	if(is_writable($path)) {
		if(is_uploaded_file($_FILES['newCommandData']['tmp_name'])) {
			if(!move_uploaded_file($_FILES['newCommandData']['tmp_name'], $path . $_FILES['newCommandData']['name'])) { 
				return "Could not store the new data file to $path";
			}
		}
	} else {
		return "$path is not writable";
	}
	return "";
}

?>
