<?php
	class Tree_Network {
		public $network;
		public $meshnodes;
		public $treeMenu;
		
		public function __construct($network) {
			if($network == null) {
				throw new Exception('Network needed');
			}
			
			$this->network = $network;
			$this->meshnodes = $network->getAllMeshnodes();
			$this->createTreeMenu();
		}
		
		private function createTreeMenu() {
			$iconMeshnode = 'meshnode.png';
			$iconPcengines = 'alix.png';
			$iconMeraki = 'meraki.png';
			$iconNetwork = 'network.png';
			$iconInformation = 'information.png';
			$iconValue = 'value.gif';
			$iconNeighbours = 'neighbours.png';
			
			$menu = new HTML_TreeMenu();
			
			$nodeNetwork = new HTML_TreeNode(
				array(
					'text' => "Network",
					'icon' => $iconNetwork,
				)
			);
			
			foreach($this->meshnodes as $meshnode) {
				$treeMeshnode = &$nodeNetwork->addItem(
					new HTML_TreeNode(
						array(
							'text' => $meshnode->name,
							'link' => "../node/index.php?node=" . $meshnode->name,
							'icon' => ${icon . ucfirst($meshnode->type)},
						)
					)
				);
				$treeInformations = &$treeMeshnode->addItem(
					new HTML_TreeNode(
						array(
							'text' => "Informations",
							'icon' => $iconInformation,
						)
					)
				);
				for($i=0; $i<1; $i++){
					$infos = array(
						'text' => "sensor networks: ",
						'icon' => $iconValue
					);
					$snMnConnections = $this->network->getAllSnMnConnections();
						//print_r($connections);
					foreach($snMnConnections as $snMnConnection) {
						foreach($snMnConnection as $sn_id => $meshnodename) {
							if($meshnodename == $meshnode->name) {
								$infos['text'] = $infos['text'] . "wsn" . $sn_id . ", ";
							}
						}
					}
					$infos['text'] = rtrim($infos['text'], " ,");
					$treeInformationValue = &$treeInformations->addItem(
						
						new HTML_TreeNode(
							$infos
						)
					);
				} 
				$treeNeighbours = &$treeMeshnode->addItem(
					new HTML_TreeNode(
						array(
							'text' => "Neighbours",
							'icon' => $iconNeighbours,
						)
					)
				);
				$neighbours = $meshnode->getNeighbours();
//print_r($neighbours);
				foreach($neighbours as $neighbour) {
					$treeNeighboursMeshnodes = &$treeNeighbours->addItem(
						new HTML_TreeNode(
							array(
								'text' => $neighbour->name,
								'icon' => ${icon . ucfirst($neighbour->type)},
								'link' => "../node/index.php?node=" . $neighbour->name,
							)
						)
					);
				}
			}
			
			$menu->addItem($nodeNetwork);
			
			// Create the presentation class
			$this->treeMenu = &new HTML_TreeMenu_DHTML(
				$menu,
				array(
					'images' => '../treemenu/images',
					'defaultClass' => 'treeMenuDefault'
				)
			);
		}
		
		private function createTreeMenuExample() {
			$icon         = 'folder.gif';
			$expandedIcon = 'folder-expanded.gif';
			
			$menu = new HTML_TreeMenu();
			
			$node1 = new HTML_TreeNode(
				array(
					'text' => "First level",
					'link' => "test.php",
					'icon' => $icon,
					'expandedIcon' => $expandedIcon,
					'expanded' => true
				),
				array(
					'onclick' => "alert('foo'); return false",
					'onexpand' => "alert('Expanded')"
				)
			);	
			$node1_1 = &$node1->addItem(
				new HTML_TreeNode(
					array(
					'text' => "Second level",
					'link' => "test.php",
					'icon' => $icon,
					'expandedIcon' => $expandedIcon
					)
				)
			);	
			$node1_1_1 = &$node1_1->addItem(
				new HTML_TreeNode(
					array(
						'text' => "Third level",
						'link' => "test.php",
						'icon' => $icon,
						'expandedIcon' => $expandedIcon
					)
				)
			);
			$node1_1_1_1 = &$node1_1_1->addItem(
				new HTML_TreeNode(
					array(
						'text' => "Fourth level",
						'link' => "test.php",
						'icon' => $icon,
						'expandedIcon' => $expandedIcon
					)
				)
			);
			$node1_1_1_1->addItem(
				new HTML_TreeNode(
					array(
						'text' => "Fifth level",
						'link' => "test.php",
						'icon' => $icon,
						'expandedIcon' => $expandedIcon,
						'cssClass' => 'treeMenuBold'
					)
				)
			);	
			$node1->addItem(
				new HTML_TreeNode(
					array(
						'text' => "Second level, item 2",
						'link' => "test.php",
						'icon' => $icon,
						'expandedIcon' => $expandedIcon
					)
				)
			);
			$node1->addItem(
				new HTML_TreeNode(
					array(
						'text' => "Second level, item 3",
						'link' => "test.php",
						'icon' => $icon,
						'expandedIcon' => $expandedIcon
					)
				)
			);
			
			$menu->addItem($node1);
			$menu->addItem($node1);
			
			// Create the presentation class
			$this->treeMenu = &new HTML_TreeMenu_DHTML(
				$menu,
				array(
					'images' => '../treemenu/images',
					'defaultClass' => 'treeMenuDefault'
				)
			);
			$listBox  = &new HTML_TreeMenu_Listbox(
				$menu,
				array(
					'linkTarget' => '_self'
				)
			);
		}
	}
?>