<?php
	class Tree_Node {
		public $meshnode;
		public $treeMenu;
		
		
		public function __construct($name) {
			if($name == null) {
				throw new Exception('Meshnodename needed');
			}
			
			$this->meshnode = new Meshnode($name);
			
			$this->createTreeMenu();
		}
		
		private function createTreeMenu() {
			$iconSensornode = 'tmote-sky.png';
			$iconMeshnode = 'meshnode.png';
			$iconPcengines = 'pcengines.png';
			$iconMeraki = 'meraki.png';
			$iconNetwork = 'network.png';
			$iconInformation = 'information.png';
			$iconValue = 'value.gif';
			$iconNeighbours = 'neighbours.png';
			
			$menu = new HTML_TreeMenu();
			
			
			$treeMeshnode = new HTML_TreeNode(
				array(
					'text' => $this->meshnode->name,
					'icon' => ${icon . ucfirst($this->meshnode->type)},
				)
			);
			$treeSensornode = &$treeMeshnode->addItem(
				new HTML_TreeNode(
					array(
						'text' => "Sensor nodes",
						'icon' => $iconInformation,
					)
				)
			);
			$sensornodes = $this->meshnode->getConnectedSensornodes();
			foreach($sensornodes as $sensornode) {
				$treeSensornodes = &$treeSensornode->addItem(
					new HTML_TreeNode(
						array(
							'text' => "sn" . $sensornode->name,
							'icon' => $iconSensornode,
							'link' => "../sensor/index.php?sensor=" . $sensornode->name,
						)
					)
				);
			}
			$treeNeighbours = &$treeMeshnode->addItem(
				new HTML_TreeNode(
					array(
						'text' => "Neighbours",
						'icon' => $iconNeighbours,
					)
				)
			);
			$neighbours = $this->meshnode->getNeighbours();
			foreach($neighbours as $neighbour) {
				$treeNeighboursMeshnodes = &$treeNeighbours->addItem(
					new HTML_TreeNode(
						array(
							'text' => $neighbour->name,
							'icon' => ${icon . ucfirst($neighbour->type)},
							'link' => "../node/index.php?node=" . $neighbour->name,
						)
					)
				);
			}
			
			$menu->addItem($treeMeshnode);
			
			// Create the presentation class
			$this->treeMenu = &new HTML_TreeMenu_DHTML(
				$menu,
				array(
					'images' => '../treemenu/images',
					'defaultClass' => 'treeMenuDefault'
				)
			);
		}
	}
?>