<?php
	class Tree_Sensor {
		public $sensornode;
		public $treeMenu;
		
		
		public function __construct($name) {
			if($name == null) {
				throw new Exception('Sensornodename needed');
			}
			
			$this->sensornode = new Sensornode($name);
			
			$this->createTreeMenu();
		}
		
		private function createTreeMenu() {
			$iconSensornode = 'tmote-sky.png';
			$iconSensors = 'sensors.png';
			$iconPcengines = 'pcengines.png';
			$iconMeraki = 'meraki.png';
			$iconNetwork = 'network.png';
			$iconInformation = 'information.png';
			$iconValue = 'value.gif';
			$iconNeighbours = 'neighbours.png';
			
			$menu = new HTML_TreeMenu();
			
			
			$treeSensornode = new HTML_TreeNode(
				array(
					'text' => "sn" . $this->sensornode->name,
					'icon' => $iconSensornode,
				)
			);
			$treeInformations = &$treeSensornode->addItem(
				new HTML_TreeNode(
					array(
						'text' => "Informations",
						'icon' => $iconInformation,
					)
				)
			);
 			$informations = $this->sensornode->getInformations();
 			foreach($informations as $information) {
				foreach($information as $key => $value) {
					$treeInformationValue = &$treeInformations->addItem(
						new HTML_TreeNode(
							array(
								'text' => "$key: $value",
								'icon' => $iconValue,
							)
						)
					);
				}
 			}

			$treeSensors = &$treeSensornode->addItem(
				new HTML_TreeNode(
					array(
						'text' => "Sensors",
						'icon' => $iconSensors,
					)
				)
			);
 			$sensors = $this->sensornode->getSensors();
 			foreach($sensors as $sensor) {
				$treeSensor = &$treeSensors->addItem(
					new HTML_TreeNode(
						array(
							'text' => $sensor->getName() ." (" . $sensor->getType() . ")",
							'icon' => $iconValue,
						)
					)
				);
				$treeSensorActualValue = &$treeSensor->addItem(
					new HTML_TreeNode(
						array('text' => 'actual value: ' . $sensor->getActualValue() . ' (<a href="">history</a>)')
					)
				);
				$treeSensorActive = &$treeSensor->addItem(
					new HTML_TreeNode(
						array('text' => 'is active: ' . $sensor->getActive())
					)
				);
				$treeSensorInterval = &$treeSensor->addItem(
					new HTML_TreeNode(
						array('text' => 'sens_interval: ' . $sensor->getInterval())
					)
				);
			}				

			$treeNeighbours = &$treeSensornode->addItem(
				new HTML_TreeNode(
					array(
						'text' => "Neighbours",
						'icon' => $iconNeighbours,
					)
				)
			);
 			$neighbours = $this->sensornode->getNeighbours();
 			foreach($neighbours as $neighbour) {
 				$treeNeighboursSensornodes = &$treeNeighbours->addItem(
 					new HTML_TreeNode(
 						array(
 							'text' => 'sn' . $neighbour->name,
 							'icon' => $iconSensornode,
 							'link' => "../sensor/index.php?sensor=" . $neighbour->name,
 						)
 					)
 				);
 			}
			
			$menu->addItem($treeSensornode);
			
			// Create the presentation class
			$this->treeMenu = &new HTML_TreeMenu_DHTML(
				$menu,
				array(
					'images' => '../treemenu/images',
					'defaultClass' => 'treeMenuDefault'
				)
			);
		}
	}
?>